package charite.christo;
import java.sql.*;
import java.net.*;
import static charite.christo.ChUtils.*;
#if 0
/*
  apt-get install libeditline-dev libreadline-dev

  http://www.kfu.com/~nsayer/Java/dyn-jdbc.html
  http://zetcode.com/db/postgresqljavatutorial/

  -cacheUrl=jdbc:postgresql://localhost/strap_cache

  createdb strap_cache
  mkdir ~/.postgresql/data
  initdb -D ~/.postgresql/data
  postmaster -D ~/.postgresql/data

  bytea_output
  http://grokbase.com/t/postgresql/pgsql-general/0365fsmz55/problem-with-bytea
  http://www.asciitable.com/

*/
#endif //0
public class CacheResultJdbc{
    private Object _con;
#define TABLE "cache"
    private static CacheResultJdbc _inst;
    public static CacheResultJdbc instance(){if(_inst==null) _inst=new CacheResultJdbc(); return _inst;}
/* <<< Options <<< */
/* ---------------------------------------- */
/* >>> Connection >>> */
    private Connection con(){
        Object conObjct=_con;
        if(conObjct==ALIAS_ERROR || prprty(iPAR_cacheUrl)==null) return null;
        if(conObjct==null){
            final String ERR0=RED_ERROR+"CacheResultJdbc ";
            Class c=null;
            URL u=null;
            try{
                final URL[]uu={url(iPathExt(iURL_STRAP_JARS_SLASH,nam(iFile(F_POSTGRESQL_JAR)),FSUFFIX_pack_gz))};
                if(interactiveDownloadAndUnzip(uu,iFile(DIR_JAVADIR_JARS)))unpack200(iFile(DIR_JAVADIR_JARS));
                else baOut(ERR0).aln("Not yet implemented");
                if(sze(iFile(F_POSTGRESQL_JAR))==0) baOut(ERR0).aFile(iFile(F_POSTGRESQL_JAR)).aln();
                else{
                    u=new URL("jar:file://"+iFile(F_POSTGRESQL_JAR)+"!/");
                    baOut(YELLOW_DEBUG).a("CacheResultJdbc url=").aln(u);
                    c=Class.forName("org.postgresql.Driver",true,new URLClassLoader(new URL[]{u}));
                }
                //baOut(YELLOW_DEBUG+"CacheResultJdbc ").a(" class=").aln(c);
                if(c!=null) DriverManager.registerDriver(new JdbcDriverProxy((Driver)c.newInstance()));
            }catch(Exception ex){errorEx(ex,ERR0,"c=",c,"url=",u);}
            String stm=null;
            boolean tableExists=false;
            Connection con=null;
            try{
                _con=con=DriverManager.getConnection(prprty(iPAR_cacheUrl),orS(prprty(iPAR_cacheUser),prprty(SYS_USER_NAME)),prprty(iPAR_cachePassword));
                baOut(YELLOW_DEBUG).a(" con=").aln(con);
            }catch(SQLException ex){errorEx(ex,prprty(iPAR_cacheUrl),orS(prprty(iPAR_cacheUser),prprty(SYS_USER_NAME)),prprty(iPAR_cachePassword));}
            if(con==null) {_con=ALIAS_ERROR; return null;}
            try{
                tableExists=con.getMetaData().getTables(null,null,TABLE,null).next();
            }catch(SQLException ex){errorEx(ex,"getMetaData().getTables()");}
            IF_MEIN_DEBUG(baOut(YELLOW_DEBUG+"CacheResultJdbc ").aa(" tableExists=",tableExists).aln());;
            if(!tableExists){
                try{
                    con.prepareStatement(stm="CREATE TABLE IF NOT EXISTS "+TABLE+"(name text, key text, value bytea, modified timestamp, hashcode int);\n").executeUpdate();
                }catch(SQLException ex){errorEx(ex,stm);}

                try{
                    con.prepareStatement(stm="GRANT ALL PRIVILEGES ON table "+TABLE+" to strap;").executeUpdate();
                }catch(SQLException ex){errorEx(ex,stm);}
                try{
                    con.prepareStatement(stm="CREATE INDEX index_key on cache (key);\n").executeUpdate();
                }catch(SQLException ex){errorEx(ex,stm);}
            }
        }
        return(Connection)conObjct;
    }
    public boolean init(){
        return prprty(iPAR_cacheUrl)!=null && con()!=null;
    }
/* <<< Connection <<< */
/* ---------------------------------------- */
/* >>> Put Get >>> */

    public boolean put(String name,String key,byte[]value,int hashcode){
        final Connection con=con();
        if(con==null) return false;
        key=key.replace('\'','_');
        String stm=null;

        try{
            final PreparedStatement pst=con.prepareStatement(stm="DELETE FROM "+TABLE+" where name='"+name+"' and key='"+key+"'");
            if(pst!=null) pst.executeUpdate();
        }catch(SQLException ex){errorEx(ex,stm);}

        try{
            final PreparedStatement pst=con.prepareStatement(stm="INSERT INTO "+TABLE+
                                                             "(name, key, value, hashcode, modified) VALUES('"+name+"', '"+key+"', ?, "+hashcode+", 'now')");
            pst.setBytes(1,value);
            pst.executeUpdate();
            puts(" SQL+ ");
            //puts(value);
            return true;
        }catch(SQLException ex){errorEx(ex,stm);}
        return false;
    }

    public BA get(String name,String key){
        byte[]value=null;
        final Connection con=con();
        key=key.replace('\'','_');
        String stm=null;
        int hc=0;
        if(con!=null){
            stm="SELECT value, hashcode from "+TABLE+" where key='"+key+"' and name='"+name+"'";
            try{
                final ResultSet rs=con.prepareStatement(stm).executeQuery();
                if(rs.next()){
                    hc=rs.getInt(2);
                    value=rs.getBytes(1);
                }
                puts(" SQL* ");
            }catch(SQLException ex){errorEx(ex,stm);}
        }

        if(value==null) return null;
        final int L=value.length;
        final BA ba=
            value[L-4]=='\\' && value[L-3]=='0' && value[L-2]=='1' && value[L-1]=='2'?new BA(L).aFilter(FILTER_DECODE_PSQL_OCTAL,value):
            new BA(value);
        IF_MEIN_DEBUG(if(strstr(0,"\\012",ba)>=0) baOut(RED_ERROR).a(" Octal: ").a(stm).special(DEBUG_EXIT));;
        if(hc!=0 && hc!=hashCd(ba)){
            if(onlyOnce(20)){
                appndToFile(new BA(99).aln().aa(RED_ERROR,"CacheResultJdbc expected hashcode=",hashCd(ba),' ',stm,';').aln(),iFile(F_ERROR_JDBC_HASCHCODE));
            }
            value=null;
        }
        return ba;
    }
/* <<< Put Get <<< */
}
#undef TABLE
