#define _initRandomAccessFile() if(_fp==null) _fp=randomAccessF(_f,"rw");
#define VERIFY_WRITE 0
public static class Archive{
    private final static Entry[]NO_ArchiveEntry={};
    private List<Entry>_v;
    private final File _f,_fIdx;
    private boolean _modified,_dirty;
    RandomAccessFile _fp;
    private static class Entry implements Comparable{
        long _time;
        int _from,_to,_hashCd;
        String _name;
        public int compareTo(Object o){return ((Entry)o)._from<_from?1: ((Entry)o)._from==_from?0: -1;}
    }

    public Archive(File f){
        _fIdx=file(new BA(99).aa(dirMkParents(_f=f),".entries"));
    }
    private List<Entry>vEntries(){
        if(_v==null){
            _v=new java.util.ArrayList();
            final long lm=_fIdx.lastModified();
            final BA ba=readBytes(_fIdx,null);
            if(ba!=null){
                baOut("Read_archive_index "+ANSI_FG_GREEN).aFile(_fIdx).aln(ANSI_RESET);
                final long len=_f.length();
                final byte[]bb=ba.bytes();
                final int ee[]=ba.eol();
                FORi(0,ee.length){
                    final int b=i==0?0:ee[i-1]+1,e=ee[i],TABS[]=new int[4];
                    if(tabulatrs('\t',bb,b,e,TABS)>3 && len>=hexToInt(bb,TABS[2]+1,e)){
                        final Entry x=new Entry();
                        x._name=byts2strg(bb,b,TABS[0]);
                        x._time=hexToLong(bb,TABS[0]+1,MAX_INT);
                        x._from=hexToInt(bb,TABS[1]+1,e);
                        x._to=hexToInt(bb,TABS[2]+1,e);
                        if(TABS[3]>0) x._hashCd=hexToInt(bb,TABS[3]+1,e);
                        _v.add(x);
                    }
                }
            }
            if(lm!=_fIdx.lastModified()) clr(_v);
        }
        return _v;
    }
    private Entry getEntry(String name){
        final List<Entry>v=vEntries();
        final int hc=(name=name.replace('\n','_')).hashCode();
        ROFi0(v.size()){
            final Entry e=v.get(i);
            if(hc==e._name.hashCode() && name.equals(e._name)) return e;
        }
        return null;
    }
    //    public boolean contains(String s) {return getEntry(s)!=null;}
    public long archiveLastModified(String s){
        final Entry e=getEntry(s);
        return e!=null?e._time:0;
    }
    public BA get(String name,BA ba){
        final Entry e=getEntry(name=name.replace('\n','_'));
        if(e==null) return null;
        if(ba==null)ba=new BA(0);
        final int len=e._to-e._from;
        byte[]bb=ba.bytes();
        if(len>bb.length) bb=new byte[len];
        try{
            _initRandomAccessFile()
                if(_fp==null) return null;
            _fp.seek(e._from);
            _fp.readFully(bb,0,len);
            ba.set(bb,0,len);
            if(e._hashCd!=0 && e._hashCd!=hashCd(bb,0,len)){
                baOut(RED_WARNING).a("ARCHIVE_WRONG_HASHCODE ")
                    IF_MEIN_DEBUG(.aFile(_f).aa(" Stored=",e._hashCd," Computed=",hashCd(bb,0,len)," len=",len," _f=",_f,' '))
                    .aln();
                clr(vEntries());
                fileDel(0,_fIdx);
                _dirty=false;

                return null;
            }
        }catch(IOException iox){
            errorEx("Archive.get",name,iox);
        }
        return ba;
    }
/* <<< Get  <<< */
/* ---------------------------------------- */
/* >>> Write >>> */
    void writeToRaf(String name,BA ba){
        if(ba==null || name==null) return;
        final byte[]T=ba.bytes();
        final int B=ba.begin(),E=ba.end(),hc=hashCd(T,B,E);
        {
            final Entry e=getEntry(name=name.replace('\n','_'));
            if(e!=null && e._to-e._from==E-B && hc==e._hashCd){
                //IF_MEIN_DEBUG(putln(ANSI_GREEN+"Archive.write NEW_TEXT==OLD_TEXT "+ANSI_RESET));;
                return;
            }
        }
        if(!_modified){
            _mapFileOutputStream.put(_fp,_f);
            _modified=true;
        }
        fileDel(0,_fIdx);
        int insertAt=-1,maxTo=0;
        {
            final List<Entry>v=vEntries();
            int insertGap=MAX_INT,lastTo=0;
            final int nE=v.size();
            if(nE>0){/*X  Fill Gaps */
                final Entry[]ee=v.toArray(NO_ArchiveEntry);
                if(nE>1) java.util.Arrays.sort(ee);
                for(Entry e:ee){
                    final int g=e._from-lastTo;
                    if(g>=E-B && g<insertGap){
                        insertAt=lastTo;
                        insertGap=g;
                    }
                    if(maxTo<(lastTo=e._to)) maxTo=lastTo;
                }
            }
        }
        try{
            final Entry e=new Entry();
            synchronized(SYNC_ARCHIVE_FP){
                _initRandomAccessFile();
                e._to=(e._from=insertAt<0?maxTo: insertAt)+E-B;
                e._time=System.currentTimeMillis();
                e._hashCd=hc;
                e._name=name;
                _fp.seek(e._from);
                _fp.write(T,B,E);
#if VERIFY_WRITE
                {
                    final byte[] verify=new byte[E-B];
                    _fp.seek(e._from);
                    _fp.readFully(verify,0,E-B);
                    if(hashCd(verify,0,E-B)!=hc) baOut(RED_ERROR).aln("verify");
                    else baOut(GREEN_SUCCESS).aln("verify");
                }
#endif //VERIFY_WRITE
            }
            vEntries().add(e);
        }catch(IOException ex){
            _dirty=true;
            errorEx(ex,"Archive.write",_f);
        }
    }
/* <<<  <<< */
/* ---------------------------------------- */
/* >>> Close >>> */
#define MAX_NUM_VALUES 50
    private void delOldestEntries(List<Entry>v){
        int n;
        while((n=v.size())>MAX_NUM_VALUES){
            int oldestIdx=0;
            long oldestTime=Long.MAX_VALUE;
            ROFi0(n){
                final Entry e=(Entry)iThEl(i,v);
                final long time=e._time;
                if(oldestTime>time){
                    oldestTime=time;
                    oldestIdx=i;
                }
            }
            v.remove(oldestIdx);
        }
    }
#undef MAX_NUM_VALUES
    boolean dispose(){
        if(_modified && !_dirty){
            //baOut("Archive save ").a(_fIdx).aln(" ...");
            final List<Entry>v=vEntries();
            delOldestEntries(v);
            CPP_synchronized(SYNC_ARCHIVE_HEADER){
                final BA sb=baClr(361);
                final int nE=v.size();
                FORi(0,nE){
                    final Entry e=(Entry)iThEl(i,v);
                    if(e==null) break;
                    if(sb!=null) {
                        sb.aa(e._name,'\t').aHexSgn(e._time).a('\t').aHexSgn(e._from).a('\t').aHexSgn(e._to).a('\t');
                        //final int pos=sb.end();
                        sb.aHexSgn(e._hashCd).a('\n');
                        //baOut(DEBUG_NOW+" aHexSgn stimmt ").aa(e._hashCd,' ').aln(e._hashCd==hexToInt(sb.bytes(),pos,sb.end())?GREEN_SUCCESS:RED_FAILED);
                    }
                }
                wrte(WRTE_REPORT_STDOUT,_fIdx,sb);
            }
            return true;
        }
        return false;
    }
    @Override protected void finalize()throws Throwable{
        logFinalize(ANSI_RED+ANSI_FG_WHITE+"Archive","");
        dispose();
        closeArchive(this);
        super.finalize();
    }
}
