package charite.christo;
import javax.swing.*;
import java.util.*;
import javax.swing.tree.*;
//import javax.swing.event.*;
import static charite.christo.ChUtils.*;
/** @author Christoph Gille */
#if 0
/*
  Well kick a giraffe if it didn't work! Here's the line of code that works:
  ((DefaultTreeModel)(codeTree.getModel())).nodeChanged(TreeNode editingNode);
  DefaultTreeModel$$valueForPathChanged(TreePath path, Object newValue) {
  Ugly, but better than what I had before:
  codeTree.treeDidChange();
  codeTree.setCellRenderer(new MyTreeRenderer());
  treeStructureChanged().
  Thanks!
*/
#endif //0
REFLECTION_PUBLIC class ChJTree extends JTree implements HasWRef,ChRunnable{
    private final int _opt;
    private boolean _needsUpdate;
    private final Runnable _threadUpdate=thrdCR1(RUN_CHJTREE_updateKeepState,this,null);
    private long _sumChildsHC;
    //private final Collection _vExpanded=new HashSet();
    //private TreePath[]_selectionPaths;
    //private final WeakHashMap _mapPath=new WeakHashMap();
    public ChJTree(int opt){
        super();
        setLargeModel(true);
        _opt=opt;
        if((JLIST_DEFAULT_RENDERER&opt)!=0) setCellRenderer(newRenderer(0));
        if((opt&JLIST_DRAG_ENABLED)!=0) setDragEnabled(true);
        pcp(KOPT_TRACKS_VIEWPORT_WIDTH,"",
            specifcLstnr(SELECTIONLI_CHANGE,
                         specifcLstnr(WLI_SCROLL,rtt(this))));
    }
    OVERRIDE_PUBLIC boolean getScrollableTracksViewportWidth(){return gcp(KOPT_TRACKS_VIEWPORT_WIDTH,this)!=null;}
    CPP_CODE_HasWRef();
/* ---------------------------------------- */
/* >>> Event >>> */
    {this.enableEvents(ENABLE_EVT_MASK);}
    OVERRIDE_PUBLIC void processEvent(java.awt.AWTEvent ev){
        if(evtIsPopupTrggr(ev)){
#define strapI IF_STRAP(_main) UNLESS_STRAP(null)
#if WRITE_CONCATENATED_JAVA||defined KEY_PROVIDE_JPopupMenu
#define r orO(gcp(KEY_PROVIDE_JPopupMenu,jc),strapI)
#else
#define r strapI
#endif //WRITE_CONCATENATED_JAVA||defined KEY_PROVIDE_JPopupMenu
            for(Object o:oo(runCR1(PROVIDE_JPopupMenu,r,ev))) shwPopupMenu(jPopupMenu(o));
        }else{
            evtClosePopupMenu(ev);
            if(!evtShouldProcess(ev) || 0!=(_opt&JLIST_DRAG_ENABLED) && jListDoDnD(ev)) return;
            if(_needsUpdate || ev.getID()==MOUSE_ENTERED) runCR1(RUN_CHJTREE_updateKeepState,this,null);
        }
        try{super.processEvent(ev);}catch(Throwable e){}
#undef r
#undef strapI
    }
/* <<< Event <<< */
/* ---------------------------------------- */
/* >>> Paint >>> */
    OVERRIDE_PUBLIC void paintComponent(java.awt.Graphics g){
/* if(gcpSetToTrue(KOPT_ALREADY_PAINTED,this)==null){ */
/*     ROFi0(gcpi(JTREE_KEY_NUM_EXPAND,this)) runCR1(RUN_CHJTREE_expandAllNodes,this,null); */
/* } */
        if(_needsUpdate){awtc(AWTC_QUEUE_UPDATEUI|AWTC_AFTER_200,this);_needsUpdate=false;}
        if(paintHooks(this,g,false)) try{super.paintComponent(g);}catch(Throwable t){stckTrc(102,t);}
        paintHooks(this,g,true);
    }
    OVERRIDE_PUBLIC void updateUI(){try{super.updateUI();}catch(Exception e){IF_MEIN_DEBUG(errorEx(e,ChJTree.class,"updateUI"));}  }
/* <<< Paint <<< */
/* ---------------------------------------- */
/* >>> Tip >>> */
    OVERRIDE_PUBLIC String getToolTipText(java.awt.event.MouseEvent ev){return ballonMsg(ev,super.getToolTipText());}
/* <<< Tip <<< */
/* ---------------------------------------- */
    CPP_RUN_ID_ARG(){
        switch(id){
            CASE_ARGV(RUN_CHJTREE_Y_COORDINATES_OF_SELECTED){
                final TreePath[]ii=getSelectionPaths();
                final int[]yy=new int[sze(ii)];
                ROFi0(yy.length){
                    final Object r=getPathBounds(ii[i]);
                    yy[i]=y(r)+hght(r)/2;
                }
                return yy;
            }
            CASE_ARGV(RUN_JCOMPONENT_AS_TEXT_SELECTED)
                CASE_ARGV(RUN_JCOMPONENT_AS_TEXT){
                final BA sb=new BA(999);
                final int rows=getRowCount();
                FORr(0,rows){
                    final TreePath tp=getPathForRow(r);
                    final boolean selected=isPathSelected(tp);
                    if(id==RUN_JCOMPONENT_AS_TEXT || selected){
                        sb.an('\n',tp.getPathCount()<3?1:0).a(selected && id==RUN_JCOMPONENT_AS_TEXT?"[x]":"   ").an(' ',1+tp.getPathCount()*2);
                        if(sb.end()==sb.a(rendererTxt(tp.getLastPathComponent())).end()) sb.a(getTxt(getCellRenderer().getTreeCellRendererComponent(this,tp.getLastPathComponent(),false,false,false,r,false)));
                        sb.aln();
                    }
                }
                return sb;
            }
#if CPP_DEACTIVATED
            CASE_ARGV(_RUN_CHJTREE_saveState){
                clr(_vExpanded);
                ROFr0(getRowCount()){
                    final TreePath p=getPathForRow(r);
                    if(isExpanded(p)) _vExpanded.add(runCR1(_RUN_CHJTREE_path2String,this,p));
                }
                _selectionPaths=getSelectionPaths();
                break;
            }
            CASE_ARGV(_RUN_CHJTREE_applySavedState){
                ROFi0(4){/*X Depth */
                    boolean changed=false;
                    ROFr0(getRowCount()){
                        final TreePath p=getPathForRow(r);
                        if(!isExpanded(p) && _vExpanded.contains(runCR1(_RUN_CHJTREE_path2String,this,p))) setExpandedState(p,changed=true);
                    }
                    if(!changed)break;
                }
                if(sze(_selectionPaths)>0) setSelectionPaths(_selectionPaths);
                break;
            }
            CASE_ARG(_RUN_CHJTREE_path2String,Object){
                Object o=_mapPath.get(path);
                if(o==null){
                    final BA sb=baClr(5);
                    for(TreePath p=(TreePath)path; p!=null; p=p.getParentPath()){
                        final Object lc=p.getLastPathComponent(),nodeId=runCR(PROVIDE_JTREE_NODE_ID,lc);
                        if(nodeId!=null) sb.a(nodeId);
                        else sb.a(rndrerHashCode(lc));
                        sb.a('/');
                    }
                    _mapPath.put(path,o=sb.toString());
                }
                RETURN o;
            }
#endif //CPP_DEACTIVATED
            CASE_ARGV(RUN_CHJTREE_node_expand)
                CASE_ARGV(RUN_CHJTREE_node_collaps){
                final TreePath[]pp=getSelectionPaths();
                if(sze(pp)==0) error("No rows selected");
                else if(pp.length<999 || id==RUN_CHJTREE_node_collaps || dlgYesNo("Really expand that many rows?")){
                    for(TreePath p:pp){
                        if(id==RUN_CHJTREE_node_collaps && !isCollapsed(p)) collapsePath(p);
                        if(id==RUN_CHJTREE_node_expand && !isExpanded(p))  expandPath(p);
                    }
                }
                break;
            }
            CASE_ARG(RUN_CHJTREE_updateKeepState,Object,afterMillisec){
                if(xatoi(afterMillisec)>0) inEDTms(_threadUpdate,xatoi(afterMillisec));
                else{
                    long sumHC=0;
                    final TreeModel m=getModel();
                    for(int /*toLen=0,*/shift=0,r=getRowCount();--r>=-1;){
                        final TreePath tp=r>=0?getPathForRow(r):null;
                        final Object parent=tp!=null?tp.getLastPathComponent():r==-1?m.getRoot():null;
                        //baOut(DEBUG_NOW+" r=").aa(r," parent=",parent,' ',shrtClasNam(parent)).aln();
                        //final int np=tp==null?1: tp.getPathCount();
                        if(parent!=null){
                            final Object[]cc=parent instanceof UniqueList?((UniqueList)parent).asArray():null;
                            ROFi0(cc!=null?cc.length:m.getChildCount(parent)){
                                sumHC+=(rndrerHashCode(cc!=null?cc[i]:m.getChild(parent,i))<<(shift++%32));
                            }
                        }
                        //toLen=np;
                    }
                    if(DIFF_MC(_sumChildsHC,sumHC)){
                        _needsUpdate=true;
                        awtc(AWTC_OPT_REPAINT|AWTC_AFTER_200,this);
#if 0
                        runCR(_RUN_CHJTREE_saveState,this);
                        //if(m instanceof ChTreeModel)  ((ChTreeModel)m).dispatch(TREE_DISPATCH_CHANGED,new TreeModelEvent(m,new TreePath(new Object[]{m.getRoot()})));
                        if(m instanceof DefaultTreeModel){
                            //putln(DEBUG_NOW+ANSI_MAGENTA+"sumHC="+sumHC+" "+ANSI_RESET+isFixedRowHeight());
                            for(TreeModelListener tml:((DefaultTreeModel)m).getTreeModelListeners()){
                                //                                final TreeModelEvent ev=new TreeModelEvent(m,new TreePath(new Object[]{m.getRoot()}));
                                final TreeModelEvent ev=new TreeModelEvent(m,new TreePath(m.getRoot()));
                                if(id==TREE_DISPATCH_CHANGED) tml.treeStructureChanged(ev);
                                if(id==TREE_DISPATCH_INSERTED) tml.treeNodesInserted(ev);
                            }
                        }
                        runCR(_RUN_CHJTREE_applySavedState,awtc(AWTC_OPT_REVALIDATE|AWTC_OPT_REPAINT,this));
#endif //0
                    }else if(runCR(RUN_CHJTREE_needsRepaint,this)==TRUEr){
                        awtc(AWTC_QUEUE_REPAINT|AWTC_AFTER_200,this);
                    }
                    runCR1(RUN_CHJTREE_expandAllNodes,this,gcp(JTREE_KEY_EXPAND,this));
                    pcp(JTREE_KEY_EXPAND,null,this);
                }
                BREAK;
            }
            CASE_ARG(RUN_CHJTREE_expandAllNodes,Object,o){
                final TreeModel m=getModel();
                ROFk0(5){
                    boolean changed=false;
                    ROFi0(maxi(m.getChildCount(m.getRoot()),getRowCount())){
                        final TreePath tp=getPathForRow(i);
                        if(tp!=null && !isExpanded(tp)){
                            final Object pc=o==null?null: tp.getLastPathComponent();
                            if(o==pc||cntainsEl(pc,o)){
                                expandPath(tp);
                                changed=true;
                            }
                        }
                    }
                    if(!changed)break;
                }
                BREAK;
            }
            IF_HOTSWAP(CASE_ARG(RUN_CHJTREE_SELECT_TREEPATH,Object,o))
                CASE_ARG(RUN_CHJTREE_scrollTo,Object,o){
                ROFi0(getRowCount()){
                    final TreePath tp=getPathForRow(i);
                    if(tp!=null && tp.getLastPathComponent()==o){
                        if(tp!=null) {
                            if(id==RUN_CHJTREE_scrollTo) scrollPathToVisible(tp);
                            IF_HOTSWAP(if(id==RUN_CHJTREE_SELECT_TREEPATH) addSelectionPath(tp));;
                        }
                    }
                }
                BREAK;
            }
            CASE_ARG(RUN_CHJTREE_selectObjects,Object,collection_or_chRunnable){
                final Object save=gcpSetToTrue(KOPT_IGNORE_SELECTION_EVT,this);
                final Collection vTP=setClr(23);
                ROFi0(getRowCount()){
                    final TreePath tp=getPathForRow(i);
                    final Object o=tp.getLastPathComponent();
                    if(collection_or_chRunnable instanceof Collection?((Collection)collection_or_chRunnable).contains(o):TRUEr==runCR1(RUN_IS_OBJECT_ENABLED,collection_or_chRunnable,o)) vTP.add(tp);
                }
                setSelectionPaths(toArry(vTP,TreePath.class));
                pcp(KOPT_IGNORE_SELECTION_EVT,save,this);
                final int count=sze(vTP);
                clr(vTP);
                RETURN io(count);
            }
            CASE_ARGV(RUN_CHJTREE_needsRepaint){
                final int L=getRowCount();
                if(L==0) return FALSEr;
                long[]hash=derefZ(gcp(_KEY_HASH_CODE,this),long[].class);
                if(sze(hash)<L) pcp(_KEY_HASH_CODE,hash=new long[L+10],this);
                final Object visible=getVisibleRect();
                final TreePath path0=getClosestPathForLocation(0,y(visible));
                if(path0==null) return FALSEr;
                boolean diff=false;
                final TreeCellRenderer rend=getCellRenderer();
                for(int y=getPathBounds(path0).y,r=getRowForPath(path0);r<L;r++){
                    final TreePath tp=getPathForRow(r);
                    final Object item=tp.getLastPathComponent();
                    if(item!=null){
                        final long hc;
                        if(item instanceof ChRunnable){
                            final long[]arr=(long[])runCR(RUN_GET_RENDERER_MC,item);
                            hc=arr==null?0:arr[0];
                        }else{
                            hc=rend==null?0:rndrerHashCode(rend.getTreeCellRendererComponent(this,item,false,false,false,r,false));
                        }
                        if(hash[r]!=hc){
                            diff=true;
                            hash[r]=hc;
                        }
                        int height=getRowHeight();
                        if(height==0) height=getPathBounds(tp).height;
                        if((y+=height)>y2(visible)) break;
                    }
                }
                return diff?TRUEr:FALSEr;
            }
            CASE_ARGV(RUN_selectedObjects){
                final Collection v=vClr(369);
                final TreePath[]pp=getSelectionPaths();
                ROFi0(sze(pp)) v.add(pp[i].getLastPathComponent());
                RETURN v.toArray();
            }
            CASE_ARG(RUN_getObjectAtPoint,Object,point){
                final TreePath tp=getPathForLocation(x(point),y(point));
                if(tp!=null) return tp.getLastPathComponent();
                BREAK;
            }
        }
        return null;
    }
#if CPP_PRG_METAN
    public void sort(int type){
        final int selRows[]=getSelectionRows();
        ROFt0(2){
            int count=0;
            ROFr0(getRowCount()){
                final TreePath tp=getPathForRow(r);
                if(!isExpanded(tp)||t>0 && idxOf(r,selRows)<0) continue;
                final Object o0=tp.getLastPathComponent();
                sortTreeNodes(ChTreeModel.rplc(o0),type);
                count++;
            }
            if(count>0) break;
        }
        runCR1(RUN_CHJTREE_updateKeepState,this,null);
    }
    private static void sortTreeNodes(Object o,int type){
        int i=szeVA(o);
        if(i>0){
            while(--i>=0){
                final Object el=xiThEl(i,o);
                if(null==gcp(KEY_DEFAULT_ORDER,el)) pcp(KEY_DEFAULT_ORDER,io(i),el);
            }
            sortArry(o,comparator(type));
        }
    }
#endif //CPP_PRG_METAN
/* <<< sort <<< */
/* ---------------------------------------- */
/* >>> DnD  >>> */
    REFLECTION_PUBLIC Object getDndDateien(){return dndV(this);}
}
