package charite.christo;
import java.io.*;
import java.util.*;
import static charite.christo.ChUtils.*;
public final class ChLogger implements ChRunnable{
    private BA _ba;
    private ChTextView _ta;
    private final int _maxLen;
    private final String _title,_icon;
    private int _countF,_countL,_opt;
    private File _swapDir,_saveFile;
    private Collection<File>_vFF=NEW_VECTOR();
    private ChJList _jlFF;
    private ChRunnable _preprocessor;
    private Object _panel,_fs;
    public ChLogger(int opt,int maxLen,String title,String icon){
        _opt=opt;
        _maxLen=maxLen;
        _title=title;
        _icon=icon;
    }
    public ChLogger setSaveLogFile(File f) {_saveFile=f; return this;}
    public void setPreprocessor(ChRunnable p) {_preprocessor=p;}
/* <<< Pane <<< */
/* ---------------------------------------- */
/* >>> append >>> */
    private final Object[]para={null,null,null};
    private synchronized ChLogger a(Object line){
        if(_ba==null) {_ba=new BA(999); _vFF=NEW_VECTOR();}
        if(isColr(line) || line==null || !withGui()) return this;
        if(line instanceof Object[]) return a(new BA(0).joinSpc(line));
        if(line instanceof Throwable) return a(stckTrc2x(null,((Throwable)line),null));
        Object line2=line;
        if(_preprocessor!=null){
            para[LOGGER_PREPROCESS_LINE]=line;
            para[LOGGER_PREPROCESS_BA]=_ba;
            para[LOGGER_PREPROCESS_THIS]=this;
            line2=runCR1(RUN_LOGGER_PREPROCESS,_preprocessor,para);
        }
        if(_ba.end()!=_ba.a(line2).end()){
            awtc(AWTC_OPT_REPAINT,_ta);
            if(_ba.end()>_maxLen) saveTmp();
        }
        return this;
    }
/* <<<  <<< */
/* ---------------------------------------- */
/* >>> Save >>> */
    private synchronized void saveTmp(){
        if(_ba==null) return;
        final int E=_ba.end();
        final byte[]T=_ba.bytes();
        int e=E;
        {
            int count=4;
            ROFi0(E){
            if(T[i]=='\n' && count--==0){
                e=i;
                break;
            }
        }
        }
        if(e>0){
            wrte(swapFile(_countF++),new BA(T,0,e));
            _countL+=countChr('\n',T,0,e);
            System.arraycopy(T,e,T,0,E-e);
            _ba.setEnd(E-e);
            if(_ta!=null) _ta.setLineNumberStart(_countL);
        }
    }
    private File swapFile(int i){
        if(_swapDir==null){
            mkdrs(_swapDir=iFile(FSUFFIX_NONE));
            thrdCR(_RUN_LOGGER_NORTH|THRDCR_EDT_LATER,this);
        }
        final File f=newFile(_swapDir,new BA(99).aa(i,".txt"));
        _vFF.add(f);
        awtc(AWTC_OPT_REVALIDATE|AWTC_OPT_REPAINT,_jlFF);
        return f;
    }
/* <<< Save <<< */
/* ---------------------------------------- */
/* >>> Event >>> */
    public void save(int opt,File f){
        if(_ba==null) return;
        try{
            final OutputStream os=fOutStrm(0,f);
            FORi(0,_countF){
                final InputStream is=new FileInputStream(swapFile(i));
                cpyNoClose(is,os,null,null);
                closeStrm(is);
            }
            _ba.writeTxt(os);
            closeStrm(os);
            if(0!=(opt&LOGGER_SAVE_DISPLAY_FILE)) new ChFrame("Written file").ad(new ChJList(JLIST_OPTIONS_FILES,oo(f))).shw(FRAME_ALWAYS_ON_TOP|FRAME_AT_CLICK|FRAME_PACK);
        }catch(IOException iox){
            errorEx(iox,"ChLogger.save",f);
        }
    }
/* <<<  <<< */
/* ---------------------------------------- */
/* >>> Thread >>> */
    CPP_RUN_ID_ARG(){
        switch(id){
            CASE_ARGV(RUN_LOGGER_SAVE){
                if(_fs==null){
                    runCR1(RUN_FCHOOSER_setCurrentDirectory,_fs=newFileChooser(PRPRTY_FS_Logger|FCHOOSER_TYPE_SAVE_DIALOG),dirMkParents(_saveFile));
                    runCR1(RUN_FCHOOSER_addFilter,addActLi(this,_fs),delToLstChr1('.',_saveFile.getName()));
                    runCR1(RUN_FCHOOSER_setSelectedFile,_fs,_saveFile);
                }
                ChFrame.frame(FRAME_ALWAYS_ON_TOP|FRAME_PACK|CLOSE_CtrlW,"Choose a script output file",_fs).shw(FRAME_CENTER);
                break;
            }
            CASE_ARGV(RUN_GET_PANEL){
                if(_panel==null){
                    if(!isEDT()){
                        thrdCR(RUN_GET_PANEL|THRDCR_EDT_NOW,this);
                        return _panel;
                    }
                    if(_ba==null) _ba=new BA(999);
                    _ta=new ChTextView(_ba);
                    if(0==(_opt&LOGGER_NO_LINE_NUMBERS)) _ta.setLineNumberStart(0);
                    Object south=pnl(_saveFile==null?null:newBut(BUTS_LOGGER_SAVE,this),newBut(BUTS_LOGGER_SEPARATOR,this),newBut(BUTS_CLEAR,this));
                    switch(idxOf(gcp(BA_KEY_SEND_TO,this),_baLog)){
                    case LOG_DND:south=pnl(CNSEW,south,null,null,buttn(TOG_reportDataFlavors));break;
                    case LOG_PROXY:south=pnl(CNSEW,south,null,null,buttn(BUTS_MAN_PAGE_PROXY).t(null));break;
                    case LOG_DOWNLOADS:south=pnl(GRIDLAYOUT(2,1),south,guiCmpnt(GUICMPNT_PRGRSS_DL));break;
                    case LOG_EXEC:south=pnl(HB,south," ","Right-click \"[Exec_1234] *\" to open control panel (Unless it has already been garbage-collected).");
                    }
                    _panel=pnl(CNSEW,scrllpn(SCRLLPN_LOCK_BOTTOM|SCRLLPN_SIZE_56x56,_ta),null,south);
                    addLi(this,LSTNR_MOMO|LSTNR_MO,_ta);
                    addLi(this,LSTNR_MOMO|LSTNR_MO,scrllpn(0,_ta));
                }
                return _panel;
            }
            CASE_ARG(RUN_APPEND,Object,o){
                if(o instanceof CharSequence && sze(o)==0) return null;
                a(o);
                if(_opt!=(_opt&=~LOGGER_ADD_TO_LOG_MENU)){
                    toLogMenu(0,this,_title,_icon,null);
                }
                BREAK;
            }
            CASE_ARG(RUN_SHOW_IN_FRAME,TYPE_FRAMEOPT,opt) RETURN(ChFrame.frame(CLOSE_CtrlW_ESC,_title,runCR(RUN_GET_PANEL,this)).shw(opt));
            CASE_ARGV(_RUN_LOGGER_NORTH){
                if(_vFF==null) _vFF=NEW_VECTOR();
                final Object pnl=runCR(RUN_GET_PANEL,this);
                adConstraintC(pnl(CNSEW,scrllpn(0,_jlFF=new ChJList(JLIST_OPTIONS_FILES,_vFF)),pnlTogglOpts(TOGGL_PNL_Externalized,scrllpn(0,_jlFF))),pnl,BorderLayout_NORTH);
                awtc(AWTC_OPT_REVALIDATE|AWTC_OPT_REPAINT,pnl);
                break;
            }
            CASE_ARG(RUN_FileChooser_APPROVE_SELECTION,Object,fileChooser){
                final File f=(File)runCR(RUN_FCHOOSER_selectedFile,_fs);
                if(isDir(f)) new BA(99).a("Error writing script:<PRE> ").aFile(f).a("</PRE>is a directory.").special(BA_ERROR);
                else if(sze(f)==0 || dlgYesNo(new BA(99).a("The file<PRE> ").aFile(f).a("</PRE>already exists.<BR>Overwrite?"))){
                    if(canModifyNiceMsg(f)) save(LOGGER_SAVE_DISPLAY_FILE,f);

                }
                BREAK;
            }
        }
        if(RUN_M_EVT_AAA<id&&id<RUN_M_EVT_ZZZ){
#define ev arg
            {
                final BA sb=(BA)gcp(BA_KEY_SEND_TO,_ta);
                if(sb!=null) sb.send();
            }
            if(evtKeyCode(ev)==VK_ENTER) a("\n");
            final int bid=evtBid(ev);
            if(bid==BUTS_CLEAR){
                fileDel(DEL_FILE_TREE,_swapDir);
                _swapDir=null;
                _countF=0;
                setTxt("",_ta);
            }
            if(bid==BUTS_LOGGER_SEPARATOR) a("#--------------------\n");
            if(bid==BUTS_LOGGER_SAVE) runCR(RUN_LOGGER_SAVE,this);

#undef ev
        }
        return null;
    }

}
