package charite.christo;
import java.util.*;
import static charite.christo.ChUtils.*;
public class ChMap<K,V>implements Map<K,V>,ChRunnable{
 transient IF_GUI(volatile) int _mc;
    private final Class _clazzK,_clazzV;
    private final int _options,_initialCapacity;
    private Object _label,_ic,_cached,_wordCompl[];
    public ChMap(){this(0,Object.class,Object.class,99);}
    public ChMap(int opt,Class cK,Class cV,int capacity){
        _clazzK=cK;
        _clazzV=cV;
        _options=opt;
        _initialCapacity=capacity;
    }

    private Map _map;
    private Map<K,V>m(){
        if(_map==null){
            _map=
                0!=(_options&MAP_TYPE_TreeMap)?new TreeMap():
                0!=(_options&MAP_TYPE_WeakHashMap)?new WeakHashMap(_initialCapacity):
                new HashMap(_initialCapacity);

        }
        return _map;
    }
    OVERRIDE_PUBLIC_IF int size(){return m().size();}
    OVERRIDE_PUBLIC_IF boolean isEmpty(){return m().isEmpty();}
    OVERRIDE_PUBLIC_IF boolean containsKey(Object key){return m().containsKey(key);}
    OVERRIDE_PUBLIC_IF boolean containsValue(Object value){return m().containsValue(value);}
    OVERRIDE_PUBLIC_IF V get(Object key){
        final Class keyClass=key==null?null:key.getClass();
        if(keyClass==Vector.class || keyClass==ArrayList.class){/*X  hashCode is variant */
            for(Map.Entry e: entryArry(m())){
                if(e.getKey()==key) return(V)e.getValue();
            }
            return null;
        }else return m().get(key);
    }
    OVERRIDE_PUBLIC_IF Set<K>keySet(){return m().keySet();}
    OVERRIDE_PUBLIC_IF Collection<V>values(){return m().values();}
    OVERRIDE_PUBLIC_IF Set<Map.Entry<K,V>> entrySet(){return m().entrySet();}

    OVERRIDE_PUBLIC_IF V put(K key,V value){
        final V old=value==null?m().get(key): m().put(key,value);
        if(value==null) m().remove(key);
        if(old!=value) {_mc++; _cached=null;}
        return old;
    }
    OVERRIDE_PUBLIC_IF void clear(){
        _mc++;
        _cached=null;
        m().clear();
    }

    OVERRIDE_PUBLIC_IF void putAll(Map<? extends K,? extends V>m){
        _mc++;
        _cached=null;
        m().putAll(m);
    }
    OVERRIDE_PUBLIC_IF V remove(Object o){
        _mc++;
        _cached=null;
        return m().remove(o);
    }
/* <<<  <<< */
/* ---------------------------------------- */
/* >>> Arrays >>> */
    private int _lastSize;
    Object[]cached(){
        Object[]oo=(Object[])deref(_cached);
        final int L=size();
        if(oo==null) _cached=newSoftRef(oo=new Object[9]);
        else if(_lastSize!=L) ROFi0(oo.length) oo[i]=null;
        _lastSize=L;
        return oo;
    }
#if CPP_DEACTIVATED
    public V[]vArray(ChRunnable run,int runID) {return (V[])toArrayKV(false,run,runID);}
    public K[]kArray(ChRunnable run,int runID) {return (K[])toArrayKV(true,run,runID);}
#endif //CPP_DEACTIVATED
    public V[]vArray(){return (V[])toArrayKV(false,null,0);}
    public K[]kArray(){return (K[])toArrayKV(true,null,0);}

    Object toArrayKV(boolean isKey,ChRunnable run,int runID){
        final Object[]cached=cached();
        Object[]vv=(Object[])cached[isKey?C_ARRAYk: C_ARRAYv];
        if(vv==null){
            cached[isKey?C_ARRAYk: C_ARRAYv]=vv=rmNullA((isKey?keySet(): new HashSet(values())).toArray(emptyArry(isKey?_clazzK:_clazzV)),isKey?_clazzK: _clazzV);
            if(run!=null) run.run(runID,vv);
        }
        return vv;
    }
/* <<<  <<< */
/* ---------------------------------------- */
/* >>> Derived >>> */
#if CPP_DEACTIVATED
    public Map<String,V[]>getMapName2objects(){
        final Object[]cached=cached();
        Map<String,V[]>m=(Map)cached[C_MAP_name2o];
        if(m==null){
            cached[C_MAP_name2o]=m=new HashMap();
            for(V v:vArray()) mapOneToMany(v,nam(v),m,2,_clazzV);
        }
        return m;
    }
#endif //CPP_DEACTIVATED
    OVERRIDE_PUBLIC boolean equals(Object o){return m().equals(o);}
    OVERRIDE_PUBLIC int hashCode(){return m().hashCode();}
    OVERRIDE_PUBLIC String toString(){return m().toString();}
/* <<<  <<< */
/* ---------------------------------------- */
/* >>> As List >>> */
#if CPP_DEACTIVATED
    private UniqueList kList,vList;
    private int _vList_mc,_kList_mc;
    public List list(boolean isKey,ChRunnable run,int runID){
        UniqueList v= isKey?kList: vList;
        if((isKey?_kList_mc: _vList_mc)!=_mc || v==null){
            if(isKey) _kList_mc=_mc;
            else _vList_mc=_mc;
            if(v==null){
                (v=new UniqueList(iCLASS_Object|UNIQL_NOT_UNIQUE)).addHookCR(_RUN__CHMAP_UPDATE_v,this,UNIQL_HOOK_ACCESS);
                if(isKey) kList=v; else vList=v;
            }else v.clear();
            if(run!=null) run.run(runID,vList);
        }
        return v;
    }
#endif //CPP_DEACTIVATED
    //public List<V>vList(ChRunnable run,int runID) {return list(false,run,runID);}
    // public List<K>kList(ChRunnable run,int runID) {return list(true,run,runID);}
    //public List<V>vList(){return list(false,null,0);}
    //public List<K>kList(){return list(true,null,"");}

/* <<< As List <<< */
/* ---------------------------------------- */
/* >>> Renderer >>> */

    //    public ChMap t(String title) {_label=title; return this;}
    //    public ChMap i(String icon) {_ic=icon; return this;}

/* <<< Renderer  <<< */
/* ---------------------------------------- */
/* >>> Word completion >>> */

#if WRITE_CONCATENATED_JAVA||defined _RUN__CHMAP_UPDATE_v
    private int _mc_vList,_mc_kList;
#endif //WRITE_CONCATENATED_JAVA||defined _RUN__CHMAP_UPDATE_v
    CPP_RUN_ID_ARG(){
        switch(id){
            CASE_ARGV(RUN_GET_ICON) return _ic;
            CASE_ARGV(RUN_GET_TEXT) return _label;
            CASE_ARG(RUN_SET_ICON,Object,ic) _ic=ic; RETURN(this);
            CASE_ARG(RUN_SET_TEXT,Object,x) _label=x; RETURN(this);
#if WRITE_CONCATENATED_JAVA||defined _RUN__CHMAP_UPDATE_v
            CASE_ARG(_RUN__CHMAP_UPDATE_v,UniqueList,v){
                Object[]addAll=null;
                if(v==vList && DIFF_MC(_mc_vList,mc())) addAll=vArray();
                if(v==kList && DIFF_MC(_mc_kList,mc())) addAll=kArray();
                if(addAll!=null){
                    v.clear();
                    adAll(addAll,v);
                }
                BREAK;
            }
#endif //WRITE_CONCATENATED_JAVA||defined _RUN__CHMAP_UPDATE_v
            CASE_ARGV(PROVIDE_WORD_COMPLETION_LIST){
                final boolean k=0!=(_options&MAP_WORD_COMPLETION_K),v=0!=(_options&MAP_WORD_COMPLETION_V);
                if(!v && !k) return null;
                if(v && k){
                    if(_wordCompl==null) _wordCompl=new Object[2];
                    _wordCompl[0]=vArray();
                    _wordCompl[1]=kArray();
                    return _wordCompl;
                }
                return v?vArray(): kArray();
            }
            CASE_ARGV(PROVIDE_STRINGMATCH_HAYSTACK)
                CASE_ARGV(PROVIDE_JTREE_CHILDS) return vArray();
        }
        return null;
    }
}
