package charite.christo;
import java.awt.*;
import java.util.*;
import static charite.christo.ChUtils.*;
/* A reimplementation of tabbed pane since JTabbedPane does not work very well */
/* @author Christoph Gille */
#define LBUT_TAB 1
#define selectedComponent() awtc(0,_center)
public class ChTabPane extends ChPanel implements Comparator{
    private final java.util.List _v=new ArrayList(),_vFocus=new ArrayList();
    private final int _opt;
    private final Object _butPrev=addActLi(this,buttn(BUTS_TABPANE_PREVIOUS)),_panTabs,_pTabs;
    private Object _jlHisto,_bSelected,_center,_panTabsPar;

    public ChTabPane(int opt){
        _opt=opt;
        setMinSze(0,0,_panTabsPar=_pTabs=pnl(pcp(RUN_PROVIDE_PREF_SIZE,this,_panTabs=pnl())));
        if(0!=(_opt&TPANE_LEFT)){
            setMinSze(3,3,this);
            pnl(this,CNSEW,null,null,null,null,addSrvc(RUN_SERVICE_PAINTHOOK,this,_panTabsPar=pnl(CNSEW,_pTabs,pnl(_butPrev))));
            _insets=new Insets(0,0,0,EX*3/2);
        }else{
            _insets=new Insets(0,EX*3/2,0,0);
            pnl(this,CNSEW,null,null,null,_panTabsPar,null);
        }
        pcp(TPANE_KEY_PANE1|PCP_OPT_WREF,_pTabs,pcp(TPANE_KEY_PANE2|PCP_OPT_WREF,_panTabs,this));
    }
    private void updateGUI(){
        awtc(AWTC_REMOVE_ALL,_panTabs);
        ((Container)_panTabs).setLayout(new GridLayout(sze(_v),1));
        for(Component jc:tabComponents()){
            final Object tog=gcp(TPANE_KEY_TAB,jc);
            if(0==(_opt&TPANE_LEFT)) pcp(_KEY_RADIOGRP,"",tog);
            adC(tog,_panTabs);
        }
        awtc(AWTC_QUEUE_REVALIDATE|AWTC_AFTER_200,_jlHisto);
        ROFi0(sze(_vFocus)) if(!_v.contains(iThEl(i,_vFocus))) _vFocus.remove(i);
        _bSelected=gcp(TPANE_KEY_TAB,selectedComponent());
        setEnbld(sze(_vFocus)>2,_butPrev);
    }
    public Component[]tabComponents(){return toArry(_v,Component.class);}
    public Component componentWithTabtext(String s){
        for(Component c:tabComponents()) if(s!=null&&s.equals(tab(c))) return c;
        return null;
    }
    public boolean removeTab(Component...cc){
        boolean success=false;
        for(Component c:cc){
            if(c!=null && _v.remove(c)){
                pcp(TPANE_KEY_PARENT_CTP,null,pcp(TPANE_KEY_TAB,null,c));
                success=true;
            }
        }
        if(success){
            runCR(_RUN_TABPANE_previousTab,this);
            handleActCmdI(ACTION_TPANE_RM,this,0);
        }
        return success;
    }

    public void addTab(int opt,Object c){
        try{
            if(c==null||c==selectedComponent()){
                handleActCmdI(ACTION_TPANE_SELECTED,this,0);
                return;
            }
            pcpAddOpt(KEY_CLOSE_OPT,opt&CLOSE_MASK,c);
            if(gcp(TPANE_KEY_WHEN,c)==null) pcp(TPANE_KEY_WHEN,io(timeOn()),c);
            {
                final Object noDups=gcp(TPANE_KEY_UNIQUE_ID,c);
                if(noDups!=null){
                    ROFi0(sze(_v)){
                        final Object jc=iThEl(i,_v);
                        if(noDups.equals(gcp(TPANE_KEY_UNIQUE_ID,jc))){
                            runCR1(_RUN_TABPANE_selectComponent,this,jc);
                            return;
                        }
                    }
                }
            }
            handleActCmdI(ACTION_TPANE_ADD,this,0);
            adUniq(specifcLstnrWithChilds(MOLI_REFRESH_TIP,pcp(TPANE_KEY_PARENT_CTP|PCP_OPT_WREF,this,c)),_v);
            if(gcp(TPANE_KEY_TAB,c)==null) pcp(TPANE_KEY_TAB,newTabButton(c),c);
            runCR1(_RUN_TABPANE_selectComponent,this,c);
            sortArry(_v,this);
            updateGUI();
            awtc(AWTC_OPT_REVALIDATE|AWTC_OPT_REPAINT,this);
        }finally{
            if(0!=(_opt&TPANE_LEFT)) setIcn(icon(c),gcp(TPANE_KEY_TAB,c));
        }
    }

    private final Insets _insets;
    private ChButton newTabButton(Object comp){
        final boolean left=0!=(_opt&TPANE_LEFT);
        final ChButton tog=(ChButton)setTip(orS(titi(TITI_TIP,comp),titi(TITI_ITEM,comp)),newButtn(left?LBUT_TAB|BUTTN_NO_FILL|BUTTN_NO_BORDER:LBUT_TAB|BUTTN_CB|BUTTN_NO_FILL|BUTTN_NO_BORDER,tab(comp),this));
        tog.setFocusable(false);
        //Object colored=HAS_COLOR(comp)?comp: HAS_COLOR(gcp(KEY_MODEL,comp))?gcp(KEY_MODEL,comp):null;
        pcp(ECHOcond(left?)BUTTN_KEY_COLOR_BOX_L:BUTTN_KEY_COLOR_BOX_R,HAS_COLOR(comp)?comp:null,
            pcp(KEY_tabComponent,wref(comp),tog));

        if(null!=gcp(KEY_CLOSE_OPT,comp)) setSmallButtonX(SMALLBUT_CLOSE,left?0:-SMALLBUT_WIDTH,tog);
        if(left){
            specifcLstnr(MOLI_TAB,tog);
            if(undockEnbld()!=-1 && 0==(_opt&TPANE_NO_UNDOCK)) pcp(KOPT_DRAW_UNDOCKABLE,"",tog);
            tog.setHorizontalTextPosition(AbstractButton_LEFT);
        }
        tog.setMargin(_insets);
        addSrvc(RUN_SERVICE_PAINTHOOK,this,
                     addLi(this,LSTNR_MO,
                           awtc(left?AWTC_SET_HORIZONTAL_ALIGNMENT_TRAILING:AWTC_SET_HORIZONTAL_ALIGNMENT_LEFT,tog)));
        setTabUndocksPnl(tog,comp);
        return tog;
    }
/* <<<  <<< */
/* ---------------------------------------- */
/* >>> AWTEvent >>> */
    CPP_RUN_ID_ARG(){
        switch(id){
            CASE_ARG(RUN_ADD_SOUTH_COMPONENT,Object,c){
                adConstraintC(c,_panTabsPar,BorderLayout_SOUTH);
                BREAK;
            }
            CASE_ARGV(RUN_TABPANE_CENTER_COMPONENT){
                return awtc(0,_center);
            }
            CASE_ARG(RUN_PROVIDE_PREF_SIZE,Object,c){
                int height=0;
                final Component[]cc=childsC(c);           ;
                if(c==_panTabs) height=mini(hght(_pTabs)-ICON_HGT,sze(_v)*ICON_HGT);
                if(c==_pTabs)   height=mini(sze(cc)*ICON_HGT,getHeight()-hght(_butPrev));
                RETURN dim(maxi(ICON_HGT,prefW(cc)),height);
            }
#define q evtSrc(ev)
#define bid evtBid(ev)
            CASE_ARG(RUN_M_actionPerformed,Object,ev){
                if(bid==LBUT_TAB && q!=_bSelected){
                    final Component pc=selectedComponent();
                    if(pc!=null) remove(pc);
                    _bSelected=q;
                    final Component c=awtc(0,gcp(KEY_tabComponent,q));
                    if(_v.contains(c)) addTab(0,c);
                }
                if(q==_butPrev){
                    if(0!=(evtModi(ev)&CTRL_MASK)){
                        if(_jlHisto==null) _jlHisto=new ChJList(JLIST_ICON_ROW_HEIGHT|JLIST_CLASS_RENDERER,_vFocus);
                        ChFrame.frame(FRAME_SCROLLPANE,"History",_jlHisto).shw(0);
                    }else runCR(_RUN_TABPANE_previousTab,this);
                    awtc(AWTC_QUEUE_REVALIDATE|AWTC_AFTER_200,_jlHisto);
                }
                BREAK;
            }
            CASE_ARG(_RUN_TABPANE_selectComponent,Object,c){
                final Component center=selectedComponent();
                if(center!=null) remove(center);
                _center=wref(c);
                if(c!=null){
                    add((Component)c,BorderLayout_CENTER);
                    if(center!=c) handleActCmdI(ACTION_TPANE_SELECTED,this,0);
                    _bSelected=gcp(TPANE_KEY_TAB,c);
                    for(Object o:tabComponents()){
                        final Object b=gcp(TPANE_KEY_TAB,o);
                        if(isToggl(b)) setSlct(o==c,b);
                        else if(o==c) awtc(AWTC_SET_OPAQUE_ON,setBG(0xFFffFF,b));
                        else awtc(AWTC_SET_OPAQUE_OFF,setBG(DEFAULT_BACKGROUND,b));
                    }
                    _vFocus.remove(c);
                    _vFocus.add(0,c);
                    awtc(AWTC_OPT_REVALIDATE|AWTC_OPT_REPAINT,this);
                    awtc(AWTC_OPT_REPAINT,_butPrev);
                }
                BREAK;
            }
            CASE_ARGV(_RUN_TABPANE_previousTab){
                if(sze(_vFocus)>0) _vFocus.remove(0);
                runCR1(_RUN_TABPANE_selectComponent,this,iThEl(0,sze(_vFocus)>0?_vFocus:_v));
                updateGUI();
                awtc(AWTC_OPT_REVALIDATE|AWTC_OPT_REPAINT,this);
                awtc(AWTC_OPT_REPAINT,_butPrev);
                break;
            }
        }
        return null;
    }
#undef q
#undef bid
/* <<< AWTEvent <<< */
/* ---------------------------------------- */
/* >>> order >>> */
    public int compare(Object o1,Object o2){
        final String k1=gcps(TPANE_KEY_SORT,o1),k2=gcps(TPANE_KEY_SORT,o2);
        int comp=k1!=null && k2!=null ?k1.compareTo(k2):0;
        if(comp==0 && (comp=gcpi(TPANE_KEY_WHEN,o1)-gcpi(TPANE_KEY_WHEN,o2))==0) comp=_v.indexOf(o1)-_v.indexOf(o2);
        return comp;
    }

}
#undef LBUT_TAB
