package charite.christo;
import java.awt.*;
import static charite.christo.ChUtils.*;
public final class ChTextArea extends javax.swing.JTextArea implements ChRunnable,Runnable,HasWRef{
    private boolean _isPainting,_isPainted;
/* >>> Constructor >>> */
    public ChTextArea(Object s){
        super(toStrgN(s));
        setWrapStyleWord(true);
        setBG(0xFFffFF,monospc(this));
        IF_PUBMED(ChPubmed.vPUBMED_TC.add(wref(this)));;
    }
    public ChTextArea(int rows,int cols) {this(""); setColumns(cols); setRows(rows);}
    OVERRIDE_PUBLIC String toString(){
        tcTools(this).loadSavedText();
        return getText();
    }
/* <<< Constructor <<< */
/* ---------------------------------------- */
/* >>> Paint >>> */
    OVERRIDE_PUBLIC boolean isOpaque(){
        return!_isPainting&&super.isOpaque();
    }
    OVERRIDE_PUBLIC void paintComponent(Graphics g){
        if(getBackground()!=null && isOpaque()){
            g.setColor(getBackground());
            fillRectBig(g,0,0,getWidth(),getHeight());
        }
        _paintHookG=g;
        if(FALSEr!=runCR1(RUN_PAINT_HOOK_BEFORE,tcTools(this),this)){
            try{
                _isPainting=true;
                super.paintComponent(g);
                _isPainting=false;
            }catch(Throwable e){}
        }
        if(!_isPainted){
            _isPainted=true;
            run();
        }
        _paintHookG=g;runCR1(RUN_PAINT_HOOK_AFTER,_tools,this);
    }
/* <<< Paint <<< */
/* ---------------------------------------- */
/* >>>  Append >>> */
    private final java.util.Collection _v=new java.util.ArrayList();
    private boolean _isRunning;
    OVERRIDE_PUBLIC void run(){
        if(sze(_v)>0){
            if(!isEDT()) inEdtLater(this);
            else synchronized(recordSync(_v,"ChTextArea run")){
                    for(Object o:_v.toArray()) appendNow(o);
                    clr(_v);
                    if(!_isRunning){
                        _isRunning=true;
                        callPeriodically(555,wref(this));
                    }
                }
        }
    }

    public ChTextArea a(Object o){
        if(o==null || !(o instanceof Color) && sze(o)==0) return this;
        if(o instanceof Object[]){
            for(Object o2:(Object[])o)  a(o2);
            return this;
        }
        if(isEDT()) appendNow(o);
        else{
            synchronized(recordSync(_v,"ChTextArea run")){
                _v.add(o instanceof CharSequence?o.toString(): o);
            }
            if(!_isRunning) run();
        }
        return this;
    }
    private int _colorPos;
    private Object _color;
    public void appendNow(Object o){
        if(o==null) return;
        if(o instanceof Color){
            final Object lastC=orO(_color,Color.WHITE);
            if(!o.equals(lastC)){
                final int len=sze(this);
                if(!lastC.equals(getBackground())) tcAddColoredBg(_colorPos,len-1,(Color)lastC,this);
                _color=o;
                _colorPos=len;
            }
        }else if((o instanceof byte[]|| o instanceof CharSequence) && sze(o)>0){
            final java.util.Collection v=vClr(1);
            ansiColorsExtract(toStrgN(o),v);
            final int N=sze(v);
            FORi(0,N){
                final Object t=iThEl(i,v);
                if(t instanceof String) append((String)t);
                else appendNow(t);
            }
            clr(v);
            if(isVisible()) undrlneRefs(ULREFS_DISABLE_UNTIL_MOUSE,this);
        }
        tcTools(this).setChanged();
    }
    public static void ansiColorsExtract(String s,java.util.Collection v){
        if(sze(s)>0){
            int from=0,ooB1=-1,m;
            while((ooB1=s.indexOf("\u001B[",ooB1+1))>=0 &&  (m=s.indexOf('m',ooB1+2))>=0){
                if(from<ooB1) v.add(s.substring(from,ooB1));
                adNotNull(ansiColorFromCode(atoi(s,ooB1+2)),v);
                from=m+1;
            }
            if(from<s.length()) v.add(s.substring(from));
        }
    }
/* <<< Append  <<< */
/* ---------------------------------------- */
/* >>> Threading  >>> */
#define bid evtBid(ev)
    CPP_FINAL_RUN_ID_ARG(){
        switch(id){
            //CASE_ARG(RUN_SET_TEXT,Object,o) runCR1(RUN_SET_TEXT,tcTools(this),o); RETURN this;
            CASE_ARG(RUN_SHOW_IN_FRAME,TYPE_FRAMEOPT,opt){
                if(gcp(KEY_SCRIPTPNL_RUN,this)!=null) pcp(KEY_OPTS_SCROLLPANE,io(SCRLLPN_CLR_BUT),this);
                RETURN(ChFrame.frame(FRAME_SCROLLPANE|CLOSE_CtrlW,"",this).shw(opt));
            }
            CASE_ARG(RUN_APPEND,Object,o){
                if(o!=null) a(o);
                BREAK;
            }
            CASE_ARG(RUN_M_keyPressed,Object,ev)
                CASE_ARG(RUN_M_actionPerformed,Object,ev){
                if(bid==BUTS_SCRIPTPNL_RUN_LINE || bid==BUTS_SCRIPTPNL_RUN_ALL || bid==BUTS_SCRIPTPNL_RUN_SELECTION || id==RUN_M_keyPressed&&evtKeyCode(ev)==VK_ENTER&&(evtModi(ev)&CTRL_MASK)!=0){
#define enter id==RUN_M_keyPressed
                    final BA ba=toBA(this);
                    int from=getSelectionStart(),to=getSelectionEnd();
                    if(bid==BUTS_SCRIPTPNL_RUN_LINE || enter&&!(from>=0 && from<to)){
                        int c=getCaretPosition();
                        if(c>=0){
                            from=1+strchrBwd(STR_E|'\n',ba,c-1,-1);
                            to=strchr(STR_E|'\n',ba,c,MAX_INT);
                            if(enter && 0<(c=strchr('\n',ba,c+1,MAX_INT)) && c<sze(ba)) setCaretPos(c+1,this);
                        }else from=to=-1;
                    }
                    if(bid==BUTS_SCRIPTPNL_RUN_ALL){
                        from=0;
                        to=MAX_INT;
                    }
                    if(from>=0 && from<to) runCR(RUN_SCRIPT_PANEL_SCRIPT,gcp(KEY_SCRIPTPNL_RUN,this),io(enter?STRAPSCRIPT_NOT_FRAME_TO_FRONT:0),new BA(ba,from,to));
                }
                BREAK;
            }
        }
        return null;
    }
#undef ev
#undef enter
/* <<< Threading <<< */
/* ---------------------------------------- */
/* >>> AWTEvent >>> */
    private int _fromTo;
    OVERRIDE_PUBLIC void processEvent(AWTEvent ev){
        if((ev=(java.awt.AWTEvent)tcTools(this)._tcProcessEvt(ev))!=null) super.processEvent(ev);
        if(gcp(KEY_SCRIPTPNL_BUT_EVAL_SELECTION,this)!=null){
            final int f=getSelectionStart(),t=getSelectionEnd();
            if(DIFF_MC(_fromTo,f+t*4096)) setEnbld(f>=0 && f<t,gcp(KEY_SCRIPTPNL_BUT_EVAL_SELECTION,this));
        }
    }
    {this.enableEvents(ENABLE_EVT_MASK);}
    final ChUtils[]_tools={null};
/* <<< AWTEvent <<< */
/* ---------------------------------------- */
/* >>> Layout >>> */
    OVERRIDE_PUBLIC String getToolTipText(java.awt.event.MouseEvent mev){
        final String tt=(String)runCR1(RUN_TXTC_TT,tcTools(this),mev);
        return tt!=null?tt:ballonMsg(mev,super.getToolTipText(mev));
    }
    OVERRIDE_PUBLIC Dimension getPreferredSize(){
        final Dimension ps=_prefSzeThis(this);
        return ps!=null?ps: super.getPreferredSize();
    }
/* <<< Layout <<< */
/* ---------------------------------------- */
    REFLECTION_PUBLIC Object getDndDateien(){return dndV(this);}
    CPP_CODE_HasWRef();
}
