
/* >>> ZIP >>> */
#if CPP_WITH_PUBMED
public static InputStream zipInStrm(String entry,ZipFile zf){
    final ZipEntry je=zf==null || entry==null?null: zf.getEntry(entry);
    try{if (je!=null) return zf.getInputStream(je);}catch(Exception ex){}
    return null;
}
#endif //CPP_WITH_PUBMED
static boolean checkIntegrityOfZipFile(File f){
    final byte[]buffer=new byte[4096];
    ZipFile zf=null;
    boolean ok=false;
    try{
        for(ZipEntry e:zipEntries(zf=new ZipFile(f),null)){
            ok=true;
            InputStream is=null;
            try{
                is=zf.getInputStream(e);
                while(is.read(buffer)!=-1){}
            }catch(IOException iox){errorEx(iox,"checkIntegrityOfZipFile",f); ok=false;break;}
            closeStrm(is);
        }
        closeStrm(zf);
    }catch(Exception e){errorEx(e,"checkIntegrityOfZipFile",f); ok=false;}

    closeStrm(zf);
    return ok;
}

public static ZipEntry[]zipEntries(Object zipFile,String name){
    ZipFile zf=derefZ(zipFile,ZipFile.class);
    if(zipFile instanceof File||zipFile instanceof CharSequence){
        try{
            zf=new ZipFile(file(zipFile));
        }catch(Exception ex){}
    }
    if(zf==null) return new ZipEntry[0];
    final Collection vE=new ArrayList(333);
    final Enumeration ee=zf.entries();
    while(ee.hasMoreElements()){
        final ZipEntry e=(ZipEntry)ee.nextElement();
        if(name==null||name.equals(e.getName())) vE.add(e);
    }
    if(zipFile!=zf) closeStrm(zf);
    return toArry(vE,ZipEntry.class);
}
public static boolean extractAll(int opt,File fTar,File dest){
    final String fn=fTar.getAbsolutePath();
    if(sze(fTar)==0){
    }else if(fn.endsWith(".jar")||fn.endsWith(".zip")){
        try{
            if(!isDir(dest)) new BA(99).aa("Error in ChZip.extractAll: ",dest," is not a directory").special(BA_ERROR);
            else{
                final ZipFile zf=new ZipFile(fTar);
                try{
                    String lastDir=null;
                    int count=0,lastTime=0;
                    final ZipEntry[]ee=zipEntries(zf,null);
                    FORi(0,ee.length){
                        final File f=newFile(dest,ee[i].getName());
                        if(f.exists()&&!isDir(f)) fileDel(0,f);
                        if(ee[i].isDirectory()) mkdrs(f);/*X Not ZipEntry.isDirectory() not to be mixed-up with isDir(File) */
                        else{
                            final File dir=f.getParentFile();
                            if(lastDir==null || !lastDir.equals(s(dir))){
                                if(dir.exists()&&!isDir(dir)) fileDel(0,dir);
                                mkdrs(dir);
                                lastDir=s(dir);
                            }

                            cpy(zf.getInputStream(ee[i]),fileDel(0,f));
                            final int time=timeOn();
                            if(time-lastTime>999){
                                new BA(99).aa(ANSI_MAGENTA+"Extracted ",fTar," #",count,'/',ee.length).special(BA_SAY_DOWNLOADING);
                                lastTime=time;
                            }
                            count++;
                        }
                    }
                    new BA(99).aa(ANSI_GREEN+"Extracted ",fTar," #",count," done").special(BA_SAY_DOWNLOADING);
                    return true;
                }catch(Exception e){extractAllError(opt,e,s(fTar),dest);}
                closeStrm(zf);
            }
        }catch(Exception e){
            extractAllError(opt,e,fn,dest);
        }
    } IF_DEACTIVATED(else return null!=runCR(RUN_PROXY_TAR,mkInstance(cloadJavaClassWithJar(BUT_C1(ChTar))),io(opt),fn,dest));
    return false;
}

private static void extractAllError(int opt,Exception e,String f,File dest){
    errorEx(e,"ChZip",f);
    if(0!=(opt&UNZIP_REPORT_ERROR)){
        new BA(99).aa("Problem extracting\n ",f,"\n to ",dest).special(BA_ERROR);
/*,0==(opt&UNZIP_SUGGEST_DEL)?"": "\nConsider to delete the file. A new file will then be downloaded."*/

    }
}
/* <<< ZIP <<< */
