/* === From Pacparser by Martyn Ayshford === */
/* >>> Emulate PAC_FUNCTION >>> */
REFLECTION_PUBLIC_STATIC boolean shExpMatch(String str,String shexp){/*X PAC_FUNCTION*/
    if(str==null||shexp==null)return false;
    final StringTokenizer tokenizer=new StringTokenizer(shexp,"*");
    int startPos=0;
    while(tokenizer.hasMoreTokens()){
        final String token=tokenizer.nextToken();
        final int temp=str.indexOf(token,startPos);
        if(temp==-1) return false;
        startPos=temp+token.length();
    }
    return true;
}
REFLECTION_PUBLIC_STATIC String myIpAddress(){/*X PAC_FUNCTION*/
    try{
        final Enumeration<NetworkInterface>interfaces=NetworkInterface.getNetworkInterfaces();
        while(interfaces.hasMoreElements()){
            final NetworkInterface i=interfaces.nextElement();
            if(i!=null && i.isUp() && !i.isLoopback() && !i.isVirtual()){
                final Enumeration<InetAddress>addresses=i.getInetAddresses();
                while(addresses.hasMoreElements()){
                    final InetAddress adr=addresses.nextElement();
                    if(Inet4Address.class.isInstance(adr)) return adr.getHostAddress();
                }
            }
        }
    }catch(Exception ex){if(onlyOnce(55)) shwTxtInW(baLog(LOG_PROXY).aa("myIpAddress",' ').aln(ex));}
    return "";
}
REFLECTION_PUBLIC_STATIC boolean isPlainHostName(String host) {return host!=null&&host.indexOf('.')<0;}/*X PAC_FUNCTION*/
REFLECTION_PUBLIC_STATIC String dnsResolve(String host){/*X PAC_FUNCTION*/
    try{
        return InetAddress.getByName(host).getHostAddress();
    }catch(UnknownHostException ex){
        if(onlyOnce(56)) shwTxtInW(baLog(LOG_PROXY).aa("dnsResolve",'(',host,')').aln(ex));
        return "";
    }
}
REFLECTION_PUBLIC_STATIC  boolean isInNet(String host,String pattern,String mask){/*X PAC_FUNCTION*/
    return sze(host=dnsResolve(host))>0 && (parseIpAddressToLong(host) & parseIpAddressToLong(mask))==parseIpAddressToLong(pattern);
}
REFLECTION_PUBLIC_STATIC long parseIpAddressToLong(String address){/*X PAC_FUNCTION*/
    long result=0,shift=24;
    for(String part:splitTkns('.',address)){
        result |= (atol(part) << shift);
        shift-=8;
    }
    return result;
}
REFLECTION_PUBLIC_STATIC boolean dnsDomainIs(String host,String domain) {return strEnds(domain,host);}/*X PAC_FUNCTION*/
REFLECTION_PUBLIC_STATIC boolean localHostOrDomainIs(String host,String domain) {return strStarts(host,domain);}/*X PAC_FUNCTION*/
REFLECTION_PUBLIC_STATIC boolean isResolvable(String host){/*X PAC_FUNCTION*/
    try{
        InetAddress.getByName(host).getHostAddress();
        return true;
    }catch(Exception ex){
        if(onlyOnce(57)) shwTxtInW(baLog(LOG_PROXY).aa("isResolvable",'(',host,')').aln(ex));
        return false;
    }
}
REFLECTION_PUBLIC_STATIC int dnsDomainLevels(String host){/*X PAC_FUNCTION*/
    int count=0,startPos=0;
    while((startPos=host.indexOf('.',startPos+1))>-1)count++;
    return count;
}
REFLECTION_PUBLIC_STATIC boolean weekdayRange(String wd1,String...pars){/*X PAC_FUNCTION*/
    String wd2="",gmt="";
    if(pars.length>0) wd2=pars[0];
    if(pars.length>1) gmt=pars[1];
    final Calendar cal;
    if("GMT".equalsIgnoreCase(wd2) || "GMT".equalsIgnoreCase(gmt)) cal=Calendar.getInstance(TimeZone.getTimeZone("GMT"));
    else cal=Calendar.getInstance();
    int start=0;
    if(sze(wd1)>0){
        int i=1;
        for(String s:arry(SARRAY_WEEKDAYS3)){
            if(s.equals(wd1))  start=i;
            i++;
        }
    }
    int end=start;
    if(wd2.length()>0){
        int i=1;
        for(String s:arry(SARRAY_WEEKDAYS3)){
            if(s.equals(wd2)) end=i;
            i++;
        }
    }
    final int currentDay=cal.get(Calendar_DAY_OF_WEEK) ;
    if(currentDay>=start && currentDay<=end) return true;
    return false;
}
REFLECTION_PUBLIC_STATIC boolean dateRange(Object day1,Object... pars){/*X PAC_FUNCTION*/
    Map<String,Integer>params=new HashMap();
    _parseDateParam(params,day1);
    FORi(0,6)if(pars.length>i) _parseDateParam(params,pars[i]);
    final Calendar cal=params.get("gmt")!=null?Calendar.getInstance(TimeZone.getTimeZone("GMT")): Calendar.getInstance();
    final Date current=cal.getTime();
    if(params.get("day1")!=null)   cal.set(Calendar_DAY_OF_MONTH,xatoi(params.get("day1")));
    if(params.get("month1")!=null) cal.set(Calendar_MONTH,xatoi(params.get("month1")));
    if(params.get("year1")!=null)  cal.set(Calendar_YEAR,xatoi(params.get("year1")));
    final Date from=cal.getTime();
    if(params.get("day2")!=null)   cal.set(Calendar_DAY_OF_MONTH,xatoi(params.get("day2")));
    if(params.get("month2")!=null) cal.set(Calendar_MONTH,xatoi(params.get("month2")));
    if(params.get("year2")!=null)  cal.set(Calendar_YEAR,xatoi(params.get("year2")));
    Date to=cal.getTime();
    if(to.before(from)){/*X  Need to increment to the next month?*/
        cal.add(Calendar_MONTH,1);
        to=cal.getTime();
    }
    if(to.before(from)){/*X  Need to increment to the next year?*/
        cal.add(Calendar_YEAR,1);
        cal.add(Calendar_MONTH,-1);
        to=cal.getTime();
    }
    return current.compareTo(from)>=0 && current.compareTo(to)<=0;
}
REFLECTION_PUBLIC_STATIC boolean timeRange(Object hour1,Object... pars){/*X PAC_FUNCTION*/
    int hour2=0,min1=0,min2=0,sec1=0,sec2=0;
/* Problem */
/*    If I get one number it's hour1,if I get two numbers it's hour1 hour2 */
/*    If I get 4 numbers it's hour1,hour2,min1,min2 */
/*    If I get 6 numbers it's hour 1,hour2,min1,min2,sec1,sec2 */
/*    Oh and I could get GMT just about anywhere,who thinks up this crap? */
    final Calendar cal=idxOfStrg(0,"GMT",pars)>=0?Calendar.getInstance(TimeZone.getTimeZone("GMT")): Calendar.getInstance();
    // GMT sorted out
    switch(idxOfStrg(0,"GMT",pars)>=0?sze(pars)-1:sze(pars)){
    case 5:
        min1=xatoi(pars[0]);
        sec1=xatoi(pars[1]);
        hour2=xatoi(pars[2]);
        min2=xatoi(pars[3]);
        sec2=xatoi(pars[4]);
        break;
    case 3:
        min1=xatoi(pars[0]);
        sec1=0;
        hour2=xatoi(pars[1]);
        min2=xatoi(pars[2]);
        sec2=59;
        break;
    case 1:
        min1=sec1=0;
        hour2=xatoi(pars[0]);
        min2=sec2=59;
        break;
    case 0:
        min1=sec1=0;
        hour2=xatoi(hour1);
        min2=sec2=59;
        break;
    }
    cal.set(Calendar_MILLISECOND,0);
    final Date current=cal.getTime();
    cal.set(Calendar_HOUR_OF_DAY,xatoi(hour1));
    cal.set(Calendar_MINUTE,min1);
    cal.set(Calendar_SECOND,sec1);
    final Date from=cal.getTime();
    cal.set(Calendar_HOUR_OF_DAY,hour2);
    cal.set(Calendar_MINUTE,min2);
    cal.set(Calendar_SECOND,sec2);
    Date to=cal.getTime();
    if(to.before(from)){
        cal.setTime(to);
        cal.add(Calendar_DATE,1);
        to=cal.getTime();
    }
    return current.compareTo(from)>=0 && current.compareTo(to)<=0;
}
/* <<< Emulate PAC_FUNCTION <<< */
/* ---------------------------------------- */
/* >>> Utils >>> */
private static void _parseDateParam(Map params,Object value){/*X Map<String,Integer>*/
    if(value instanceof Number){
        final int n=xatoi(value);
        if(n<=31){/*X  Its a day*/
            if(params.get("day1")==null) params.put("day1",io(n));
            else params.put("day2",io(n));
        }else{/*X  Its a year*/
            if(params.get("year1")==null) params.put("year1",io(n));
            else params.put("year2",io(n));
        }
    }
    int n=-1;
    if(value instanceof String){
        int i=1;
        for(String s:arry(SARRAY_MONTHS3)){
            if(s.equals(value)){
                n=i;
                // fudge to get month to map up properly
                n--;
            }
            i++;
        }
    }
    if(n>-1){/*X Its a month*/
        if(params.get("month1")==null)  params.put("month1",io(n));
        else params.put("month2",io(n));
    }
    if("GMT".equalsIgnoreCase(value.toString())) params.put("gmt",io(1));
}
private static Collection _vProxies(String txt/*,URI uri*/){
    Collection v=null;
    IF_DEACTIVATED(if(onlyOnceHC(300,uri)) baLog(LOG_PROXY).aa(uri," ==> ").aln(txt));;
    for(String s:splitTkns(SPLIT_ALLOW_EMPTY_TOKENS|';',txt)){
        if((s=s.trim()).startsWith("DIRECT")) v=adUniqNew(Proxy.NO_PROXY,v);
        else if(s.startsWith("PROXY")){
            final int h=nxt(0,chrClas(LETTR),s,5,MAX_INT);
            if(h>0){
                final int colon=s.indexOf(':',h);
                v=adUniqNew(new Proxy(Proxy.Type.HTTP,new InetSocketAddress(s.substring(h,colon),atoi(s,colon+1))),v);
            }
        }
    }
    return v;
}
#define M "FindProxyForURL"
@*SARRAY_PACPARSER_ARGS
a|a,b|a,b,c
*@
REFLECTION_PUBLIC_STATIC_VOID setProxyPac(int method,int url,CPP_AS_OBJECT(CharSequence)txtOrUrl){
    if(sze(txtOrUrl)!=0 && isProbeProxyContinue()){
        final BA log=baLog(method);
        if(txtOrUrl instanceof BA){/*X When recursively invoked the BA. When from outside, then String.*/
            boolean ok=true;
            if(0>strstr(STR_w,M,txtOrUrl)){
                log.aa("Does not contain ",M).aln(RED_FAILED).aa(ANSI_FG_BLUE,txtOrUrl).aln(ANSI_RESET);
                if(null!=prprty(iPAR_PROXY_PAC)) setTxt("Autoprobe proxy failed",JCC[JC_WARN_NO_INTERNET_GOING_TO_AUTOPROBE]);
            }else{
                log.aa("Contains ",M).aln(GREEN_SUCCESS);
                final javax.script.ScriptEngine e=new javax.script.ScriptEngineManager().getEngineByName("JavaScript");;
                IF_MEIN_DEBUG(String eval=null);;
                try{
                    if(javaVsn()>17) e.eval(IF_MEIN_DEBUG(eval=)"var pacparser=Java.type('"+CLASS_ChUtils+"');");/*X  rhino or Nashorn */
                    else e.put("pacparser",chUtils());
                    e.eval(IF_MEIN_DEBUG(eval=)s(txtOrUrl));
                    final BA sb=new BA(5555);
                    //final String[]pp=splitTkns("a a,b a,b,c");
                    for(java.lang.reflect.Method m:ChUtils.class.getMethods()){
                        switch(m.getName().hashCode()){
                        case CPP_HASHCD(shExpMatch):
                        case CPP_HASHCD(myIpAddress):
                        case CPP_HASHCD(isPlainHostName):
                        case CPP_HASHCD(isInNet):
                        case CPP_HASHCD(parseIpAddressToLong):
                        case CPP_HASHCD(dnsDomainIs):
                        case CPP_HASHCD(localHostOrDomainIs):
                        case CPP_HASHCD(isResolvable):
                        case CPP_HASHCD(dnsDomainLevels):
                        case CPP_HASHCD(weekdayRange):
                        case CPP_HASHCD(dateRange):
                        case CPP_HASHCD(dnsResolve):
                        case CPP_HASHCD(timeRange):{
                            final String p=iConst(SARRAY_PACPARSER_ARGS,m.getParameterTypes().length-1);
                            sb.aa(m.getName(),"=function(",p,"){return pacparser.",m.getName(),'(',p).aln(");};");
                        }
                        }
                    }
                    e.eval(IF_MEIN_DEBUG(eval=)s(sb));
                }catch(Exception ex){
                    IF_MEIN_DEBUG(errorEx(ex,eval));;
                    REFLECTION_RETURN;
                }
                final ProxySelector ps=new PacProxySelector(e);

                if(url>=0){
                    ok=false;
                    try{
                        for(Object proxy:oo(ps.select(new URI(urlToTestInternet(url))))){
                            if(isProbeProxyContinue() && !ok){
                                final InetSocketAddress a=((Proxy)proxy).type()==Proxy.Type.DIRECT?null:(InetSocketAddress)((Proxy)proxy).address();
                                ok=_proxyTestConf(a==null?"":a.getHostName(),a==null?null:s(a.getPort()),method,url);
                            }
                        }
                    }catch(Exception ex){IF_MEIN_DEBUG(errorEx(ex));;}
                }
                if(ok){
                    ProxySelector.setDefault(ps);
                    setInternetOK(CTRUE,method);
                    if(method!=PROBE_PROXY_LAST) wrte(WRTE_IF_HC,iFile(F_PROXY_LAST),txtOrUrl);
                }
            }
        }else if(onlyOnceHC(301,txtOrUrl)){
            log.aa("Reading ",txtOrUrl).aln(" ...");
            InputStream is=null;
            try{
                is=url(txtOrUrl).openConnection(Proxy.NO_PROXY).getInputStream();
            }catch(Exception ex){log.aln(ex);}
            log.del('\n').del(" ...").aln(GREEN_DONE);
            txtOrUrl=readBytes(is);
            closeStrm(is);
            if(sze(txtOrUrl)==0) log.aln(RED_FAILED);
            else{
                log.a(ANSI_FG_BLUE).aFT(txtOrUrl,0,prgOptOn(iPAR_DEBUG_PROXY)?80:MAX_INT).aln(ANSI_RESET);
                setProxyPac(method,url,txtOrUrl);
            }
        }
    }
    REFLECTION_RETURN;
}
#define _PPS_connectFailed 0
#define _PPS_select 1
static ProxySelector _def;
private static Collection _pps(int id,PacProxySelector pps,Object...arg){
    if(id==_PPS_connectFailed && onlyOnce(50)) shwTxtInW(baLog(LOG_PROXY).aShrtClasNam(PacProxySelector.class).a(".connectFailed ").aln(arg));
    if(id==_PPS_select){
        final URI uri=(URI)arg[0];
        if(uri!=null){
            try{
                Collection v=_vProxies(s(((javax.script.Invocable)pps._engine).invokeFunction(M,s(uri),uri.getHost()))/*,uri*/);
                if(v!=null) return v;
            }catch(Exception ex){
                if(onlyOnce(138)) shwTxtInW(baLog(LOG_PROXY).aa(ex,'\n').aShrtClasNam(PacProxySelector.class).aa('.',M,' ').aln(uri));
            }
        }
        if(_def==null) _def=ProxySelector.getDefault();
        return _def.select(uri);
    }
    return null;
}
CPP_PRIVATE static class PacProxySelector extends ProxySelector{
    final javax.script.ScriptEngine _engine;
    PacProxySelector(javax.script.ScriptEngine e) {_engine=e;}
    OVERRIDE_PUBLIC void connectFailed(URI u,SocketAddress a,IOException ex){_pps(_PPS_connectFailed,this,u,a,ex);}
    OVERRIDE_PUBLIC List<Proxy>select(URI uri) {return (List)_pps(_PPS_select,this,uri);}
}
#undef M
#if CPP_DEACTIVATED_MAIN
/*
  java charite.christo.ChUtils https://www.fool.co.uk  ~/.StrapAlign/log/pac.txt
*/
public static void main(String[]argv)throws Exception{
    setNoGui(argv);
    final String url_input=argv[0];
    final BA pacTxt=readBytes(argv[1]);
    final ProxySelector ps=setProxyPac(PROBE_PROXY_PAC1,pacTxt);
    putln(" ProxySelector="+clazz(ps));
    if(ps!=null){
        for(Object p:oo(ps.select(url(argv[0]).toURI()))){
            final InetSocketAddress a=(InetSocketAddress)((Proxy)p).address();
            putln("PacparserTest "+a.getHostName()+":"+a.getPort());
        }
    }
}
#endif //CPP_DEACTIVATED_MAIN
