@*?CUSTOM_latexBegin
@*?CUSTOM_texshadeBegin
@*?CUSTOM_texshadeEnd
Three constant sections of the LaTeX source code are customizable:
<UL><LI>The LaTeX preamble</LI>
<LI>The beginning of the TEXshade block.</LI>
<LI>The end of the TeXshade block.</LI>
</UL>
*@
@**CUSTOM_latexBegin
\documentclass{letter}
\usepackage{texshade}
*@
@**CUSTOM_texshadeBegin
\pagestyle{empty}
\begin{texshade}{MSF_FILE}
\seqtype{P}
\gapchar{.}
*@
@**CUSTOM_texshadeEnd
\end{texshade}
*@
@**CUSTOM_fetchProteinFile
UNIPROT:
UNIPARC:
EMBL:
NCBI:
KEGG_AA:
KEGG_NT:
ENSEMBL:
*@
@*?CUSTOM_fetchProteinFile
URLs to get protein files from. Asterisk $* is replaced by the ID.
*@
@*?CUSTOM_strapApps
An App is a local or remote program that reads the Strap data and generates an HTML page and/or a script.
The preferences text has two tab-separated columns:
<OL>
<LI>Display name</LI>
<LI>
Shell command/Web URL which can be executed with the status file as argument.
For local programs, an asterisk is a placeholder for the path of the xml file.
</LI>
</OL>
*@
@**CUSTOM_strapApps
#Tab-separated Columns (Type Ctrl+I to insert a tab)
#  1st Column: Display name *
#  2nd Column: A shell script or URL *
demo/Web/Simple Example 1\t RPLC_DEMOPHP
demo/Web/Example 2 with C-alpha 3D-coordinates\t RPLC_DEMOPHP?-CALPHA_COORDINATES-
demo/Web/Example 3 with C-alpha 3D-coordinates if selected\t RPLC_DEMOPHP?-CALPHA_COORDINATES_IF_SELECTED-
demo/Web/Example 4 with C-alpha 3D-coordinates with server side cache\t RPLC_DEMOPHP?-SERVER_CACHE-CALPHA_COORDINATES-
demo/Local Programs/Example 1 - Only script          \tSH echo aa_sequence Hello-World, Test_protein3
demo/Local Programs/Example 2 - Print the XML file   \tSH cat *
demo/Local Programs/Example 4 - As above but request atom coordinates.\tSH cat * # ATOM_COORDINATES
*@
#if 0
(highlight-regexp "ATOM_COORDINATES\\|CALPHA_COORDINATES\\|FILE_CONTENT\\|ATOM_COORDINATES_IF_SELECTED\\|CALPHA_COORDINATES_IF_SELECTED\\|FILE_CONTENT_IF_SELECTED")
#endif //0

@*@CUSTOM_strapApps
<HTML><BODY>
<PRE class="strap_script">sequence hello-world, Test_protein.seq</PRE>
<H2>This is the output of the example script</H2>
Within in PRE tags of class "strap_script", a script can be given which is run by Strap.
In this example, the script consists of one command to create a new protein object named "Test_protein" and the sequences "hello-world".
If the command line or URL contains the string "ATOM_COORDINATES" then the generated XML file will contain the PDB format of all sequences
that have 3D-structure information. You can see the XML-file by holding the Ctrl-key when clicking the node.
See <A href="http://www.bioinformatics.org/strap/strap_script.html">Script commands</A>
</BODY></HTML>
*@
@*?CUSTOM_annotationTypes
Types of annotations in residue selections
*@
@**CUSTOM_annotationTypes
Todo
*@
@*?CUSTOM_replaceResiduesLine
Generate a text from the table rows.
The contents of the table cells are addressed by backslash followed by to digits indicating the column.
*@
@**CUSTOM_replaceResiduesLine
SwissViewer $X = select in 0 num \10; mutate $X to "\05";
SwissViewer $X = select in 0 pos \02+1; mutate $X to "\05"
Pymol select strapMut, ( ///\12/\10 ); mutate PROTEIN, strapMut, \07; delete strapMut;
*@
@**CUSTOM_examplesBackground
http://www.bioinformatics.org/strap/images/sun_java.png
data:image/gif;base64,R0lGODdhBgAGAKEDANwRERFL3CDcEf///ywAAAAABgAGAAACDZyBNgjKAkcIUMigVAEAOw==
*@
@**CUSTOM_examples3D
spheres
ribbons
sticks
lines
surface
color #FF0000
color #FF00AA
*@
@**CUSTOM_examplesNote
Experimental confirmation awaited
Is a cleaved
Is modified
Is important for catalysis
Example with variables: First amino acid is $FIRST_AAA $FIRST_INDEX
PUBMED:10547838 PDB:1RYP EMBL:X59417
*@
@**CUSTOM_examplesRemark
Important note
Experimantal confirmation awaited
*@
@**CUSTOM_examplesBalloon
A Balloon text that appears when the mouse is over
*@
@**CUSTOM_examplesEvidence
Potential
By similarity
By identity
Experimental
Manual assertion
*@
@**CUSTOM_examplesAtoms
.CA
.CA.CB
.C*.S*.N*
*@
@**CUSTOM_execSearchPath
/pathAddedBySettings
*@
@*?CUSTOM_execSearchPath
Directories for searching executable programs.
One absolute path per line.
Precedence over paths in the environment variable PATH.
Backslash or forward slash - no matter.
Can contain environment variables such as %ProgramFiles%.
Try <i>HTMLDOC_BUTTON:BUT_DEBUG_EXE_SEARCH_PATH!</i>.
*@
@*?CUSTOM_proteinFileExtensions
File extensions of protein and alignment files. Used for the file browser.
Does not affect interpretation of the file contents is interpreted!
*@
@**CUSTOM_proteinFileExtensions
.pdb .ent .dssp .cif  # Structure file
.swiss .swissprot .sw .swp   # SwissProt sequence file
.embl   # EMBL sequence file
.genbank .gb   # Genbank (see menu 'translate dna ..')
.dna .nt   # Nucleotides a,c,t,g
.fa .fasta .mfa   # Fasta-format
.ascii .txt .text .seq  # Plain text
.msf .clustalw .aln .pir   # Multiple sequence file containing more than one sequence
PD* PF*   # Prodom and PFAM alignment files
*@
