package charite.christo.strap;
import charite.christo.*;
import static charite.christo.ChUtils.*;
import static charite.christo.strap.Strap.*;
public class CompareTwoProteinsImpl implements CompareTwoProteins,ChRunnable{
    private Object _choiceAligner,_shared,_ctrl,_aligner,_method;/*X  TabCompareSequences.java*/
    private double _value=Double.NaN;
    private int _mc;
    private final int _it;
    public CompareTwoProteinsImpl(int it){
        _it=it;
        _method=
            _it==COMPARE_PP_SEQUENCE_IDENTITY_AS_ALIGNED||_it==COMPARE_PP_ALIGN_SCORE_AS_ALIGNED?null:
            it==COMPARE_PP_SUPERIMPOSE_SCORE||it==COMPARE_PP_SUPERIMPOSE_RMSD?sclDefaultForInterface(INTRFC_Superimpose3D):
            io(BUT_C1(Needleman_Wunsch));
    }
    CPP_FINAL_RUN_ID_ARG(){
        switch(id){
            CASE_ARG(RUN_M_actionPerformed,Object,ev){
                if (evtSrc(ev)==_choiceAligner) _method=selItemJC(_choiceAligner);
                BREAK;
            }
            CASE_ARG(RUN_IS_OBJECT_ENABLED,Object,p){
                RETURN(_it!=COMPARE_PP_SUPERIMPOSE_SCORE&&_it!=COMPARE_PP_SUPERIMPOSE_RMSD||p instanceof Protein && hasCalpha((Protein)p)?TRUEr:FALSEr);
            }
            CASE_ARGV(RUN_DISPOSE){
                dispos(_aligner);
                return TRUEr;
            }
            CASE_ARG(RUN_SET_SHARED_INSTANCE,Object,o){
                _shared=o;
                BREAK;
            }
            CASE_ARGV(RUN_GET_SHARED_INSTANCE){
                return _shared;
            }
            CASE_ARG(RUN_GET_SHARED_CTRL_PNL,Object,supported){
                if(_it!=COMPARE_PP_SEQUENCE_IDENTITY_AS_ALIGNED&&_it!=COMPARE_PP_ALIGN_SCORE_AS_ALIGNED){
                    if(supported==PROPERTY_SUPPORTED) return PROPERTY_SUPPORTED;
                    if(_ctrl==null){
                        _ctrl=pnl(VB,pnl(" Method ",getPnl(addActLi(this,setSelO(_method,_choiceAligner=classChoice(_it==COMPARE_PP_SUPERIMPOSE_SCORE||_it==COMPARE_PP_SUPERIMPOSE_RMSD?INTRFC_Superimpose3D:INTRFC_SequenceAligner))))));
                    }
                    return _ctrl;
                }
                BREAK;
            }
            CASE_ARG(RUN_GET_CTRL_PNL,Object,supported){
                if(_it!=COMPARE_PP_SEQUENCE_IDENTITY_AS_ALIGNED&&_it!=COMPARE_PP_ALIGN_SCORE_AS_ALIGNED) return supported==PROPERTY_SUPPORTED?PROPERTY_SUPPORTED:ctrlPnl(_aligner);
                BREAK;
            }
            CASE_ARG(RUN_STRAP_EVENT,int[],evtType){
                if(evtType[0]==EVT_ALIGNMENT&&(_it==COMPARE_PP_SEQUENCE_IDENTITY_AS_ALIGNED||_it==COMPARE_PP_ALIGN_SCORE_AS_ALIGNED)) strapEvtDispatch(EVT_SEQUENCE_SEQUENCE_DISTANCE|SEVTMS*333);
                RETURN TRUEr;
            }
        }
        return null;
    }
#define MODI_COUNT (_it==COMPARE_PP_SEQUENCE_IDENTITY_AS_ALIGNED||_it==COMPARE_PP_ALIGN_SCORE_AS_ALIGNED?p0.MC[P_MC_GAPPED_SEQ]:0)+ p0.MC[P_MC_RES_TYPE]+p1.MC[P_MC_RES_TYPE]+p0.hashCode()+p1.hashCode()
    public double compareTwoProteins(int opt,Protein p0,Protein p1,int fromCol,int toCol){
        if(p0==null||p1==null) return Double.NaN;
        if(0!=(opt&COMPARE_PP_SHOW_RESULT_GRAPHICALLY)||DIFF_MC(_mc,MODI_COUNT)){
            if(fromCol>0 || toCol<=p0.getResColumnMax()) p0=p0.newProteinSubset(new int[]{p0.columnToIndex(CTRUE,fromCol),p0.columnToIndex(CFALSE,toCol)});
            if(fromCol>0 || toCol<=p1.getResColumnMax()) p1=p1.newProteinSubset(new int[]{p1.columnToIndex(CTRUE,fromCol),p1.columnToIndex(CFALSE,toCol)});
            double v=Double.NaN;
            byte[][]aligned=null;
            if(_it==COMPARE_PP_SEQUENCE_IDENTITY_AS_ALIGNED||_it==COMPARE_PP_ALIGN_SCORE_AS_ALIGNED) aligned=new byte[][]{p0.getGappedSequence(true),p1.getGappedSequence(true)};
            else{
                {
                    final CompareTwoProteinsImpl s=(CompareTwoProteinsImpl)deref(_shared);
                    if(null==(_aligner=mkInstance(MKINSTANCE_SHOW_ERROR,(s!=null?s:this)._method))) return Double.NaN;
                    if(0!=(opt&COMPARE_PP_SHOW_RESULT_GRAPHICALLY)){
                        viewComparison(p0,p1,_aligner);
                        return Double.NaN;
                    }
                }
                if(_it==COMPARE_PP_SUPERIMPOSE_SCORE||_it==COMPARE_PP_SUPERIMPOSE_RMSD){
                    final Object[]r=superimposeTwoProteins(0,_aligner,p0,p1);
                    if(r!=null)v=xatof(r[_it==COMPARE_PP_SUPERIMPOSE_SCORE && r[ALIGNRESULT_SCORE]!=null?ALIGNRESULT_SCORE:ALIGNRESULT_RMSD]);
                }else if(_it==COMPARE_PP_ALIGN_SCORE||_it==COMPARE_PP_SEQUENCE_IDENTITY){
                    aligned=(byte[][])iThEl(ALIGNRESULT_GAPPED,((SequenceAligner)_aligner).computeAlignment(0,new Protein[]{p0,p1}));
                    final Object score=runCR(RUN_GET_SCORE,_aligner);
                    if(_it==COMPARE_PP_ALIGN_SCORE) v=score!=null?xatof(score):pairAignScore(-10,-1,aligned[0],aligned[1],0,MAX_INT,-BLOSUM62_MIN);
                }
            }
            if(sze(aligned)==2){
                if(_it==COMPARE_PP_ALIGN_SCORE_AS_ALIGNED){
                    v=pairAignScore(-10,-1,aligned[0],aligned[1],fromCol,toCol,-BLOSUM62_MIN);
                }else{
                    final long ratio=alignmentIdentity(aligned[0],aligned[1],0,MAX_INT);
                    if(0<ratio) v=NUMERATOR_BY_DENOMINATOR(double,ratio);
                }
            }
            _value=0!=(opt&COMPARE_PP_TURN_INTO_DISTANCE_VALUE) && _it>=COMPARE_PP_DISSIMILARITY_ZZZ?-v:v;
        }
        return _value;
    }

}
