package charite.christo.strap;
import java.io.*;
import java.util.*;
import charite.christo.*;
import static charite.christo.ChUtils.*;
import static charite.christo.strap.Strap.*;
#if 0
/*
  $STRAP_SRC/mail/notes/Bioinf/PDB_Format.txt
  $STRAP_SRC/mail/notes/Bioinf/CIF_Format.txt

  entGz=/home/c/ROOT_DIRECTORIES/local/bioinf/DB/PDB/divided/ht/pdb1htq.ent.gz
  entGz=/local/bioinf/DB/PDB/divided/ry/pdb1ryp.ent.gz
  reset; time java charite.christo.strap.PDBParserTest -localPDB='/local/bioinf/DB/PDB/divided/$id23/pdb$id.ent.gz' $entGz
  java charite.christo.strap.PDBParserTest T

  java charite.christo.strap.CIFParser ~/m1/CIF/11AS.cif.gz
   java charite.christo.strap.CIFParser  /home/ROOT_DIRECTORIES/local/bioinf/DB/CIF/a2/pdb2a2e.cif.gz
   polydeoxyribonucleotide 1gd2
   polypeptide
   polyribonucleotide 1q82
   _entity_poly.type _monomer

   reset; java charite.christo.strap.PDBParserTest atomsOnly1.pdb
   reset; java charite.christo.strap.CIFParser  CIF/1SBC.cif.gz

   FST_LINE_OF_CHAIN  _seqres24, _mapHet
   _as__label_asym_id  _as__auth_asym_id

   Kein _loopAlign:1AOI

*/
//   cd /local/bioinf/DB/CIF/; reset; java charite.christo.strap.CIFParser  */*.gz 2>&1 | tee kannWeg cif_msg.txt
                                                                                 // /local/bioinf/DB/CIF$ zfgrep '~' */*.gz  #  pdb132l
#endif //0
public class PDBParserTest implements Runnable{
    private static File _f;
    public void run(){
        baOut("reset; java ").aa(nam(PDBParserTest.class)," ",_f,"\n emacsclient ",_f," &").aln();
    }
    final static String STYLE=ANSI_FG_RED+ANSI_GREEN, MSG0=STYLE+"PDBParserTest> "+ANSI_RESET;
    public static void main(String[]argv)throws Exception{

        setNoGui(argv);
        //checkFieldNames();
        Runtime.getRuntime().addShutdownHook(toThrd(new PDBParserTest()));
        for(String a:argv){
            if(!a.startsWith("-")){
                _f=file(a);
                baOut(MSG0).a("File=").aFile(_f).aln();
                final BA txt=readBytes(_f);
                if(sze(txt)==0) {baOut(MSG0).a(RED_ERROR).aln("File empty."); continue;}
                if(true){
                    final String[]chainsByType[]=chainsInPdbOrCif(txt), chains=chainsByType[CHAINTYPE_PEP];
                    if(chains.length==0){
                        baOut(MSG0).a("No peptide chain").aln();
                        FORi(CHAINTYPE_FST,CHAINTYPE_LST_PRIMARY) baOut(MSG0).aa(" "+ANSI_INVERSE,iConst(SARRAYeq_STRAP_OBJECT_TITLE,i),ANSI_RESET+": ").joinSpc(chainsByType[i]).aln();
                        continue;
                    }
                    for(String chain:chains){
#if 0
                        if(!"Z".equals(chain)){
                            if(onlyOnce(51)) baOut(MSG0).a(RED_WARNING).aln(" SKIPPING CHAINS");
                            continue;
                        }
#endif //0
                        baOut(MSG0).aa(STYLE," chain=").a(chain).a(" of ").join(JOINGLUE_SPC_COMMA_SPC,chains).aln(ANSI_RESET);
                        final Protein p=new Protein();
                        final ProteinParser parser=sequenceParser(strEnds(STR_IC,arry(SARRAY_DOT_PDB_ENT_also_GZ),txt.getFile())?BUT_C1(PDBParser):BUT_C1(CIFParser)));
                        {
                            int opt=0;
                            //opt|=PROTPARS_NO_SEQRES;
                            parser.parse(opt,chain,txt,p);
                        }
                        final Collection vTxt=new ArrayList();
                        if(false){
                            strapInstance(SEQWRITER_PDB).getProteinText(SEQW_COMPLETE_PDB,p,null,null,vTxt);
                            baOut(MSG0+"\n").join0(vTxt).aln();
                        }else if(true){
                            p.sequenceInStrapFormat(0,null,clr(vTxt));
                            final BA txt2=new BA(0).join0(vTxt);
                            baOut(MSG0+"\n").aln(txt2).a(ANSI_BLUE).an('E',80).aln(ANSI_RESET);
                            if(true){
                                final Protein p2=new Protein();
                                final ProteinParser parser2=newScriptInterpreter();
                                parser2.parse(0,chain,txt2,p2);
                                p2.sequenceInStrapFormat(0,null,clr(vTxt));
                                baOut(MSG0+"\n").join0(vTxt).aln().a(ANSI_BLUE).an('e',80).aln(ANSI_RESET);
                            }

                        }

                        //baOut(MSG0+" getResidueSecStrType=").a(p.getResidueSecStrType()).aln();
#if 0
                        getAssemblyMatrices(p);
                        parser.parse(0,chain,txt,p);
#endif //0
                    }
                }
            }
        }
        System.exit(0);/*X Main*/
    }
#if 0
    private static void checkFieldNames(){
        final Map m=finalStaticConstantsMap();
        final byte[]ss[]=CIFParser.STRING;
        final BA err=new BA(999),code=new BA(999),src=javaSrc(nam(CIFParser.class)),sb_Unused=new BA(999);
        final int srcBegin=strstr(0,"hashCd(STRING[i]",src);
        for(Map.Entry e:entryArry(m)){
            if(!(e.getKey() instanceof String)) continue;
            final String name=(String)e.getKey();
            if(!name.startsWith("CIF")) continue;
            final int val=xatoi(e.getValue());
            CharSequence n=name;
            n=strplc(0,"CIFs_","struct.",n);
            n=strplc(0,"CIFsr_","struct_ref.",n);
            n=strplc(0,"CIFe_","entity.",n);
            n=strplc(0,"CIFss_","struct_site.",n);
            n=strplc(0,"CIFssg_","struct_site_gen.",n);
            n=strplc(0,"CIFas_", "atom_site.",n);
            n=strplc(0,"CIFsc_","struct_conf.",n);
            n=strplc(0,"CIFssr_","struct_sheet_range.",n);
            n=strplc(0,"CIFesg_","entity_src_gen.",n);
            n=strplc(0,"CIFep_","entity_poly.",n);
            n=strplc(0,"CIFpsmr_","pdbx_struct_mod_residue.",n);
            n=strplc(0,"CIFsmpc_", "struct_mon_prot_cis.",n);
            n=strplc(0,"CIFsco_", "struct_conn.",n);
            n=strplc(0,"CIFesn_", "entity_src_nat.",n);
            n=strplc(0,"CIFpsag_", "pdbx_struct_assembly_gen.",n);
            n=strplc(0,"CIFpsol_", "pdbx_struct_oper_list.",n);
            n=strplc(0,".matrix11", ".matrix[1][1]",n);
            n=strplc(0,".matrix12", ".matrix[1][2]",n);
            n=strplc(0,".matrix13", ".matrix[1][3]",n);
            n=strplc(0,".vector1",  ".vector[1]",n);
            n=strplc(0,".matrix21", ".matrix[2][1]",n);
            n=strplc(0,".matrix22", ".matrix[2][2]",n);
            n=strplc(0,".matrix23", ".matrix[2][3]",n);
            n=strplc(0,".vector2",  ".vector[2]",n);
            n=strplc(0,".matrix31", ".matrix[3][1]",n);
            n=strplc(0,".matrix32", ".matrix[3][2]",n);
            n=strplc(0,".matrix33", ".matrix[3][3]",n);
            n=strplc(0,".vector3",  ".vector[3]",n);

            if(n==name) continue;
            if(val<0||val>=ss.length) err.a(e).a(" out of range");
            else if(!strEquAt(0,ss[val],n,0)){
                if(ss[val]!=null) err.a(e).a(" current STRING[").a(name).a("]=").a(ss[val]).aln();
                code.a("  ss[").a(name).a("]=\"").a(n).aln("\";");
            }
            if(strstr(0,name,src,srcBegin,MAX_INT)<0) sb_Unused.a(name).a(' ');

        }
        if(sze(sb_Unused)>0) baOut(RED_WARNING).a(" Not Used ").aln(sb_Unused);
        if(sze(code)>0){
            // baOut(RED_ERROR).a("PDBParserTest checkFieldNames ").a(err).aln().aln(code).special(DIE_NOW);
        }
        //        putln(src);
    }
#endif //0
    public static void testSimplifyTitle(){
        final String[]ss={
            "50S RIBOSOMAL PROTEIN L33, 50S RIBOSOMAL PROTEIN L34, 50S RIBOSOMAL PROTEIN L35, 50S RIBOSOMAL PROTEIN L36, THIOSTREPTON, 50S RIBOSOMAL PROTEIN L2, 50S RIBOSOMAL PROTEIN L4, 50S RIBOSOMAL PROTEIN L5, 50S RIBOSOMAL PROTEIN L6, 50S RIBOSOMAL PROTEIN L11, 50S RIBOSOMAL PROTEIN L13, 50S RIBOSOMAL PROTEIN L14, 50S RIBOSOMAL PROTEIN L15, 50S RIBOSOMAL PROTEIN L16, 50S RIBOSOMAL PROTEIN L17, 50S RIBOSOMAL PROTEIN L18, 50S RIBOSOMAL PROTEIN L19, 50S RIBOSOMAL PROTEIN L20, 50S RIBOSOMAL PROTEIN L21, 50S RIBOSOMAL PROTEIN L22, 50S RIBOSOMAL PROTEIN L23, 50S RIBOSOMAL PROTEIN L24, 50S RIBOSOMAL PROTEIN L25, 50S RIBOSOMAL PROTEIN L27, 50S RIBOSOMAL PROTEIN L28, 50S RIBOSOMAL PROTEIN L29, 50S RIBOSOMAL PROTEIN L30, 50S RIBOSOMAL PROTEIN L3",
            "DNA-directed RNA polymerase alpha chain (E.C.2.7.7.6), DNA-directed RNA polymerase beta chain (E.C.2.7.7.6),",
            "Histone H3.1t, Histone H4, Histone H2A type",
            "BOVINE PANCREATIC TRYPSIN INHIBITOR (BPTI, BASIC) MUTANT WITH CYS 30 REPLACED BY VAL AND CYS 51 REPLACED BY ALA (C30V,C51A)",
            "CHLORAMPHENICOL ACETYLTRANSFERASE (TYPE III) (E.C.2.3.1.28) MUTANT WITH HIS 195 REPLACED BY GLN (H195Q) (ENGINEERED)"
        };

        for(String s:ss){
            baOut(ANSI_INVERSE).a(s).aln(ANSI_RESET).a(SequenceParserImpl3D.simplifyTitle(toBA(s))).aln().aln();
        }
    }
    public static void asymLabelAndAuth(int rchnLabl,int rchnAuth, int b){
        final BA sb=baClr(60);
        final String authAsym=clr(sb).aBytes(rchnAuth).toString(), labelAsym=clr(sb).aBytes(rchnLabl).toString();
        final Object prev=_mapLabelToAsym.put(labelAsym,authAsym);
        if(prev!=null && !prev.equals(authAsym)){
            ((BA)runCR(RUN_PDBCIF_LOG_ERROR,sequenceParser(BUT_C1(PDBParser)))).aln(" ASYM_ONE_LABEL_SEVERAL_AUTHOR");
            SequenceParserImpl3D.errLine(b,0x0202|PDB_ERR_LINE_FROM_POS);
        }
    }

/*
 private final static int
        _hetLast,
        PRIME_NUMBER=8867, SEQRES_HASH[]=new int[PRIME_NUMBER/32+1], // http://www.miniwebtool.com/list-of-prime-numbers/?to=10000

    private static boolean _hetInline;
    private static boolean isInlineHet(int resType24, int resNumIns) { // e.g. pdb1q7e
        final int hash=resType24%PRIME_NUMBER;
        if(0==(SEQRES_HASH[hash>>>5]&(1<<(hash&0x1f)))) return false;
        if(resNumIns==_hetLast) return _hetInline;
        _hetLast=resNumIns;
        _hetInline=idxOf(resNumIns, _modresResn, 0, _modresL)>=0;
        if(!_hetInline){
            final String txt=baClr(VCLR_NUMBERS).a("  _hetInline=").a(_hetInline).a(' ').aBytesAdj(resType24,4).a(' ').a(resNumIns>>>8).a(' ').a(_id4).a('_').a(_chain).toString();
            if(onlyOnceHC(304,txt)) baOut(RED_WARNING).a(txt).aln();
        }
        return _hetInline;
    }
*/

/*
    if(e-b>83 && T[b]=='_' && T[b+2]=='u' && strEquAt(0,"_audit_conform.dict_location ",T,b)
        && strEquAt(0,"http://mmcif.pdb.org/dictionaries/ascii/mmcif_pdbx.dic",T,nxt(no_spc,T,b+28,e))){
        _isCif=true;
        break;
    }
                        Above does not work for obsolete entry 347d.cif
*/

}
