package charite.christo.strap;
/**   A ProteinWriter is used to export a protein to a text file   using a certain format such as pdb or fasta.   @author Christoph Gille */
public interface ProteinWriter{
       /* Writes the protein data e.g. in fasta or PDB format */
       /* @return true: was able to produce the text,false: unable to produce the text because information is not set in the protein model. */
       /* A ProteinWriter for protein structures returns false if the coordinate fields in the Protein instance are empty. */
    java.util.Collection<byte[]>getProteinText(int opt,Protein p,Matrix3D[]m3d,Object residues,java.util.Collection<byte[]>vTxt);
    /**  index of first and last amino acid    */
    //void setResidueRange(int indexOfFirstAmino,int indexOfLastPlus1);

    /** do not write all residues but only a certain subset.*/
    //void selectResidues(boolean[]isSelected);

}
