/* >>> ChUtils_AA_Inc.java >>> */
#define aaUrlToCachefile(url)  file(_aaCacheFilePath(null,url))
private static byte[]_aaCacheDir;
private static byte[]aaCacheDir(){
    if(_aaCacheDir==null) _aaCacheDir=toByts(iPath2(DIR_CACHE,null));
    return _aaCacheDir;
}
public static boolean aaIsFileInCache(File f){
    return f!=null && !isPrprty(IS_AA_SETUP) && !isPrprty(IS_F1000) && strStarts(aaCacheDir(),f);
}
/* clas==null means URL download */
#define CACHE_SPLIT_NUM 256
public static BA _aaCacheFilePath(Object clas,CPP_AS_OBJECT(CharSequence)key){
    //IF_MEIN_DEBUG(if(isPrprty(IS_F1000)||isPrprty(IS_AA_SETUP)) baOut(RED_ERROR).a(" not use _aaCacheFilePath if IS_F1000 or IS_AA_SETUP").special(DIE_NOW));;
    final long hc=hashCdL(key,0,MAX_INT);
    final BA ba=new BA(222).a(aaCacheDir());
    if(clas==null) ba.a("Download/");else ba.aLstCmpnt('.',clas).a('/');
    ba.a((hc>=0?hc:-hc)%CACHE_SPLIT_NUM).a('/').aHex(hc);
    if(clas==null) ba.and(".",imgFileDotExt(key));
    return ba;
}
#undef CACHE_SPLIT_NUM
public static BA aaCacheGet(Object clas,CPP_AS_OBJECT(CharSequence)key,BA buffer){
    if(!isPrprty(IS_CACHE_READ)) return null;
    final BA path=_aaCacheFilePath(clas,key),txt=readBytes(path,buffer);
    if(txt==null){
        final BA header=readBytes(path.a(".header"));
        if(header==null){
            baOut(RED_ERROR).aa("aaCacheGet ","MISSING_HEADER_FILE\t").aFile(path).aln();
            return txt;
        }
        final byte[]T=header.bytes();
        final int E=header.end(),tab=strchr('\t',T,0,E);
        if(tab<0){
            baOut(RED_WARNING).aa("aaCacheGet ","MISSING_TAB\t").aln(path);
            return null;
        }
        if(tab!=sze(key)||!strStarts(key,header)){
            baOut(RED_WARNING).aa("aaCacheGet ","WRONG_KEY\t").aln(path);
            return null;
        }
        final long hcHeader=hexToLong(T,tab+1,E),hcTxt=hashCdL(txt);
        if(hcHeader!=hcTxt){
            baOut(RED_WARNING).aa("aaCacheGet ","WRONG_HASH_CODE\t",hcHeader,'~',hcTxt,' ').aln(path);
            return null;
        }
    }
    return txt;
}
public static void aaCachePut(Object clas,CPP_AS_OBJECT(CharSequence)key,BA txt){
    if(!isPrprty(IS_CACHE_WRITE)) return;
    final BA ba=_aaCacheFilePath(clas,key);
    final File f=file(ba);
    wrte(WRTE_IF_DIFF_LEN,newFile(f.getParentFile(),"index.html"),"<HTML>\n<BODY>\nNo access\n</BODY>\n</HTML>\n");
    wrte(f,txt);
    aaCacheMkHeader(key,hashCdL(txt),ba);
}
public static void aaCacheMkHeader(CPP_AS_OBJECT(CharSequence)key,long hc,Object filePath){
    wrte(file(toBA(filePath).a(".header")),new BA(sze(key)+20).aa(key,'\t').aHex(hc,'\n'));
}

/* <<< Cache <<< */
/* ---------------------------------------- */
/* >>> Cache Download >>> */
public static File aaCacheDlUrl(String url){
    if(url==null) return null;
    final File fTmp=iFile(FSUFFIX_dowload);
    dlUrlToFile(url,fTmp);
    if(sze(fTmp)==0){
        baOut(RED_FAILED).aa("aaCacheDlUrl "," Download url ==> fTmp  ",url," ==> ").aFile(fTmp).aln();
        fileDel(0,fTmp);
        return null;
    }
    final BA path=_aaCacheFilePath(null,url);
    final File f=file(path);
    renamFile(fTmp,f);
    if(sze(f)==0){
        baOut(RED_FAILED).aa("aaCacheDlUrl "," Failed to rename fTmp ==> f  ").aFile(fTmp).a(" ==> ").aFile(f).aln();
        return null;
    }
    aaCacheMkHeader(url,hashCdF(f),path);
    return f;
}

public static BA aaDownloadToSessionDir(String url){
    final File f=file(new BA(222).a("DownloadedSequences/").aFilter(FILTER_NO_MATCH_TO_US|FILENM,url).delIC(".gz"));
    BA txt=null;
    if(sze(f)!=0){
        txt=readBytes(f);
    }else if(strstr(STR_w,HTTP_NOT_REUSABLE,url)>=0 || !isPrprty(IS_CACHE_READ)){
        cpy(inStrm(INSTREAM_NO_DECOMPRESS,url),f);
        txt=readBytes(f);
    }else{
        if(sze(txt=aaCacheGet(null,url,null))==0){
            aaCacheDlUrl(url);
            txt=aaCacheGet(null,url,null);
        }
        if(sze(txt)>0){
            lnkOrCpy(FILE_DEL_BEFORE,aaUrlToCachefile(url),f);
            txt.setFile(f);
        }else{
            baOut(RED_FAILED).a("aaDownloadToSessionDir ").aln(url);
        }
    }
    return txt;
}
/* <<< WITH_AA_CACHE <<< */
/* ---------------------------------------- */
/* >>> AA File >>> */

#if CPP_WITH_READ_FILE_SECURITY
private static String[]_aaAllowedDir;
private static String[]aaAllowedDirs(){
    if(_aaAllowedDir==null){
        String[]ss=splitTkns(':',prprty(iPAR_DIRECTORIES));
        ROFi0(3){
            final String d=rmQuotes('"',i==0?iFile(DIR_PRGDATA): i==1?delFromChar('$',prprty(iPAR_LOCAL_PDB)): iFile(DIR_THIS_JAR_PARENT));
            if(d!=null && !strStarts(ss,d)) ss=adToStrgs(d,ss,0);
        }
        for(String d:_relativeUrls) if(d!=null && !strStarts(ss,d)) ss=adToStrgs(d,ss,0);
        _aaAllowedDir=ss;
        ROFi0(ss.length) ss[i]=addSfx("/",ss[i]);
        baOut("\n"+ANSI_INVERSE+"File access"+ANSI_RESET).joinSpc(_aaAllowedDir).aln(ANSI_RESET);
    }
    return _aaAllowedDir;
}
public static boolean aaCanNotRead(Object f){
    if(f!=null && !strStarts(aaAllowedDirs(),f)){/*X  && strstr(0,"/"+DIRNAME_WWW_DATA+"/"++"/",f)<0*/
        if(onlyOnceHC(308,f.toString())){
            baOut(RED_ERROR).a("Accesses denied ").aFile(f)
                .a("\n "+ANSI_INVERSE+"Accessible directories: "+ANSI_RESET).joinSpc(aaAllowedDirs())
                .aln("\n Note for administrators: Accessible directories must be specified with the command line option "+PAR_DIRECTORIES).special(STCKTRC);
        }
        return true;
    }
    return false;
}
#endif //CPP_WITH_READ_FILE_SECURITY
/* <<< AA File <<< */
/* ---------------------------------------- */
/* >>>  >>> */
