#define URL_NOT_VALID_ANY_MORE_2017(x)

@**CUSTOM_pdbFiles
CPP_UNSTRINGIZE(URL_PFX_DOWNLOAD_PDB)$id.cif.gz
https://www.ebi.ac.uk/pdbe-srv/view/files/$id.cif
http://files.rcsb.org/download/$id.cif.gz
URL_NOT_VALID_ANY_MORE_2017(http://pdbj.org/rest/downloadPDBfile?format=mmcif&id=$id)
URL_NOT_VALID_ANY_MORE_2017(https://www.ebi.ac.uk/cgi-bin/dbfetch?db=uniprotkb&style=raw&id=)
URL_NOT_VALID_ANY_MORE_2017(UNIPARC: https://www.ebi.ac.uk/cgi-bin/dbfetch?db=uniparc&style=raw&id=)
*@

@**CUSTOM_obsoletePdbFiles
ftp://ftp.ebi.ac.uk/pub/databases/rcsb/pdb/data/structures/
ftp://ftp.wwpdb.org/pub/pdb/data/structures/
#ftp://ftp.ipr.pdbj.org/pub/pdb/data/structures/
#if CPP_DEACTIVATED
https://www.ebi.ac.uk/pdbe-srv/view/files/$id.ent.gz
ftp://ftp.ebi.ac.uk/pub/databases/rcsb/pdb/data/structures/divided/mmCIF/$id23/$id.cif.gz
#endif //CPP_DEACTIVATED
*@

@**CUSTOM_databases
$UP=https://www.uniprot.org
$NCBI=https://www.ncbi.nlm.nih.gov
GFF_UNIPROT: $UP/uniprot/?format=gff&query= ##!hslv_ecoli~Beta strand
NCBI_NEIGHBOR: https://structure.ncbi.nlm.nih.gov/Structure/vast/vastsrv.cgi?sdid=
VAST: https://structure.ncbi.nlm.nih.gov/Structure/vast/vastsrv.cgi?sdid= ##!123~alignment
URL_NOT_VALID_ANY_MORE_2017(http://www.ncbi.nlm.nih.gov)
URL_NOT_VALID_ANY_MORE_2017(http://eutils.ncbi.nlm.nih.gov)
PMID: PUBMED: PMID pmid $NCBI/entrez/eutils/efetch.fcgi?db=pubmed&retmode=text&rettype=medline&id= ##!24813445~Alignment
# *** SEARCH: ***
UNIPROT_EC: $UP/uniprot/?_LiStOfIdS_&sort=score&format=list&query=ec: ##!1.1.1.1~P06525
UNIPROT_QUERY: $UP/uniprot/?_LiStOfIdS_&sort=score&format=list&query= ##!hexokinase~P35557
*@

@**CUSTOM_proteinDatabases
$UP=https://www.uniprot.org
$NCBI=https://www.ncbi.nlm.nih.gov
$EFETCH=https://eutils.ncbi.nlm.nih.gov/entrez/eutils/efetch.fcgi?retmode=text&rettype=gp&id=
$EBI_FETCH=CPP_UNSTRINGIZE(URL_EBI_DBFETCH)?style=raw
# *** Alignments ***
URL_NOT_VALID_ANY_MORE_2017($NCBI/Structure/cdd/cddsrv.cgi??seqout=1&maxaln=-1&uid=)
URL_NOT_VALID_ANY_MORE_2017(http://pfam.xfam.org/family/alignment/download/gzipped?acc=*&alnType=full&.gz)
URL_NOT_VALID_ANY_MORE_2017(https://www.ebi.ac.uk/cgi-bin/dbfetch)
PFAM_FULL: http://pfam.xfam.org/family/*/alignment/full/gzipped?.gz ##!PF00097~Zinc finger
PFAM: http://pfam.xfam.org/family/*/alignment/seed/gzipped?.gz ##!PF00097~Zinc finger
# *** SEQUENCES ***
UNIPARC: UPI: $UP/uniparc/*.fasta ##!UPI0000000001~MGAAASI
UR090: UNIREF090: $EBI_FETCH&db=UR090&id=
UR050: UNIREF050: $EBI_FETCH&db=UR090&id=
UR100: UNIREF100: $EBI_FETCH&db=UR100&id=

EMBL: $EBI_FETCH&db=EMBL&id= ##!M57965~ID +M57965;
EMBLCDS: $EBI_FETCH&db=emblcds&id=  ##!M57965~ID +M57965;
SWISS: EXPASY: Swiss-Prot: SWISSPROT: $UP/uniprot/*.txt ##!P24495~AC +P24495
UNIPROT: UNIPROTKB: $EBI_FETCH&db=uniprotkb&id= ##!P24495~AC +P24495
IPI: $EBI_FETCH&db=IPI&id=
# The id will be analyzed and db=NCBI_PROTEIN_OR_NUCLEOTIDE will be replaced either by protein or nucleotide.
# NT_123456 constructed genomic contigs
# NM_123456 mRNAs
# NP_123456 proteins
# NC_123456 chromosomes
# XM_123456 predicted mRNA
# XP_123456 predicted protein
REFSEQ: RefSeq: NCBI: ENTREZ: $EFETCH*&db=NCBI_PROTEIN_OR_NUCLEOTIDE ##!NP_000033~beta-2-glycoprotein
NCBI_NT: Gi: GI: GB: GENBANK: GenBank:  $EFETCH*&db=nucleotide ##!153266840~mRNA
NCBI_AA: GENPEPT: GenPept: $EFETCH*&db=protein ##!NP_000033~glycoprotein

KEGG_AA: https://www.genome.jp/dbget-bin/www_bget?-f+-n+a+ ##!dge:Dgeo_2222~subtilisin
KEGG_NT: https://www.genome.jp/dbget-bin/www_bget?-f+-n+n+ ##!eco:b0002~aspartokinase
PRODOM: http://prodomweb.univ-lyon1.fr/prodom/current/cgi-bin/request.pl?db_ent0= ##!PD000267~^CONSENSUS|
URL_NOT_VALID_ANY_MORE_2017(FSSP: ftp://ftp.embl-heidelberg.de/pub/databases/protein_extras/fssp/*.fssp.Z)
URL_NOT_VALID_ANY_MORE_2017(HSSP: ftp://ftp.embl-heidelberg.de/pub/databases/protein_extras/hssp/*.hssp)
URL_NOT_VALID_ANY_MORE_2017(SYSTERS_CLUSTER: http://systers.molgen.mpg.de/cgi-bin/nph-fileout.pl?method=m&nr=)

#Indirekt See seqRefsInHtmlFile
MMDB: NCBI_3D: $NCBI/Structure/pdb/ ##!57342~1SBC


# *** STRUCTURE: ***
VIPERDB: http://viperdb.scripps.edu/API2/api_get_structure.php?VDB= ##!1dzl~REMARK 350
*@
