package charite.christo.strap;
import static charite.christo.ChUtils.*;
import static charite.christo.strap.Strap.*;

public class AcceptAlignment2{

    private final Row[]_rows;

    private final int[]_countInserts,_startIdx;
#if CPP_WITH_GUI
    public static int eliminateCommonGaps(Protein[]pp,int startCol,int endCol,byte[][]alignment,int[]wide2view){
        int c1=startCol,c2=endCol;
        if(alignment!=null){
            c1=MAX_INT;
            c2=0;
            FORr(0,pp.length){
                c1=mini(c1,startCol);
                c2=maxi(c2,startCol+countChrClas(chrClas(LETTR),alignment[r],0,MAX_INT));
            }
        }
        final int c2W=idxOf(c2,wide2view);
        final int c1W=maxi(idxOf(c1,wide2view),0);
        final int deleted=Gaps2Columns.g2cEliminateCommonGaps(pp,c1W,c2W>c1W?c2W:MAX_INT);
        return deleted;
    }
#endif //CPP_WITH_GUI
    public static void delGaps(Protein[]pp,int startCol,int endCol,byte[][]alignment){
        final Object key=new Object();
        ROFiP0(pp.length){
            final Protein p=pp[iP];
            final int iA1=p.columnToIndex(CTRUE,startCol);
            if(iA1<0) continue;
            final int iA2=alignment!=null?iA1+countChrClas(chrClas(LETTR),alignment[iP],0,MAX_INT): p.columnToIndex(CTRUE,endCol);
            pcp(key,new int[]{iA1,iA2>=0?iA2:p.countRes()},p);
        }
        for(Protein p:pp){
            final int ii[]=(int[])gcp(key,p),iA1=iThInt(0,ii),gg[]=p.getResGap(),iA2=mini(p.countRes(),iThInt(1,ii));
            int count=0;
            FORa(iA1+1,iA2){
                if(gg!=null && a<gg.length) count+=gg[a];
                p.setResidueGapAt(false,a,0);
            }
            if(count>0) p.setResidueGapAt(true,iA2,count);
        }
        for(Protein p:pp) pcp(key,null,p);
    }

    public AcceptAlignment2(Protein[]pp,int startCol,byte[][]alignment){
        if(alignment!=null) delGaps(pp,startCol,MAX_INT,alignment);
        final int nP=sze(pp);
        _rows=new Row[nP];
        _startIdx=new int[nP];
        _countInserts=new int[nP];

        if(alignment==null) return;
        FORr(0,nP){
            final byte[]gg=gappedSequenceWide(pp[r]);
            final int col=idxOfLetters(alignment[r],gg,startCol,MAX_INT);
            _startIdx[r]=countChrClas(chrClas(LETTR),gg,0,col);
#if CPP_WITH_GUI
            Protein[]ppRow=getProteinsSameRow(pp[r]).clone();
#else
            Protein[]ppRow=new Protein[]{pp[r]};
#endif //CPP_WITH_GUI
            if(ppRow.length==0) ppRow=new Protein[]{pp[r]};
            ROFi0(ppRow.length) ppRow[i]=newP(ppRow[i]);
            _rows[r]=new Row(newP(pp[r]),ppRow,alignment[r]);
        }
        accept();
        for(Row r:_rows){
            for(Protein p:r._all) ((Protein)gcp(_KEY_AcceptAlignment2_ORIG,p)).setResidueGap(p.getResGap());
        }
        IF_GUI(setNotSaved());;
    }
    static byte[]gappedSequenceWide(Protein p){
        final int gg[]=p.getResGap(),nR=p.countRes();
        final byte[]aa=p.getResType(),gapped;
        int col=nR;
        if(gg!=null) ROFi0(mini(nR,gg.length)) col+=gg[i];
        gapped=new byte[col];
        //java.util.Arrays.fill(gapped,(byte)0);
        col=0;
        FORi(0,nR){
            if(gg!=null&&i<gg.length) col+=gg[i];
            gapped[col++]=aa[i];
        }
        return gapped;
    }
    IF_GUI(public int[]getCountInserts(){return _countInserts;});;
    private void accept(){
        final Row[]stacks=_rows;
        final byte[][]aa=new byte[stacks.length][],ali1d=new byte[stacks.length][];
        FORr(0,stacks.length){
            aa[r]=stacks[r]._gapped;
            ali1d[r]=stacks[r]._top.getGappedSequence(true);
        }
        final int[][]inserts=mergeAlignments(_startIdx,aa,ali1d);
        final Object key=new Object();
        FORr(0,stacks.length){
            for(Protein p:stacks[r]._all){
                final int nR=p.countRes(),gg0[]=p.getResGap(),gg[]=sze(gg0)<nR?chSze(gg0,nR):gg0.clone();
                pcp(key,gg,p);
                if(gg!=null){
                    addGapAtColumn(r,inserts[r],gg,p.columnsToIndices(),p.getResColumnMax());
                }
            }
        }
        FORr(0,stacks.length){
            for(Protein p:stacks[r]._all){
                p.setResidueGap((int[])gcp(key,p));
                pcp(key,null,p);
            }
        }
    }
    private void addGapAtColumn(int row,int[]insert,int resGap[],int[]c2i,int maxCol){
        final int colMax=mini(maxCol,c2i.length-1,insert.length);
        ROFc0(colMax){
            int a=c2i[c];
            if(a<0 && (a=nxtNotnegativeIdx(c2i,a+1,colMax))<0) continue;
            if(a>=resGap.length || insert[c]==0) continue;
            resGap[a]+=insert[c];
            _countInserts[row]+=insert[c];
            //lastChangedA[row]=maxi(a,lastChangedA[row]);
        }
    }
    private static int nxtNotnegativeIdx(int[]nn,int pos,int to){
        int v=-1,i=pos;
        if(nn.length<to) to=nn.length;
        while(i<to && (v=nn[i])<0) i++;
        return(v>=0)?i:-1;
    }
    private static Protein newP(Protein p){
        final Protein neu=new Protein();
        //neu.setName("x"+p.getName());
        neu.setResidueType(p.getResType());
        neu.setResidueGap(p.getResGap());
        pcp(_KEY_AcceptAlignment2_ORIG,p,neu);
        return neu;
    }

    /* --- Instance --- */
    private static class Row{
        final Protein _top,_all[];
        final byte[]_gapped;
        public Row(Protein top,Protein[]all,byte[]gapped){
            _top=top;
            _all=all;
            _gapped=gapped;
        }
    }

}
