//private Map<String,ReferenceSequence>_refseqMap;
#define _refseqDownloadV vNoClr(364|VCLR_VECTOR)
IF_GUI(static boolean _refseqDownloading);;

private final class ReferenceSequence IF_GUI(extends Thread){
    final Object _p,_files[];/*X  File or BA */
    final Protein _pRef;
    final String _id;
    java.net.URL _url;
    short[]_u2i;
    boolean _downloaded;
    int _mc;
/* >>> Instance >>> */
    ReferenceSequence(String id,Protein p){
        _id=id;
        _p=wref(p);
        final Object[]ff=_files=new Object[2];
        _pRef=null;
        IF_LocalSequenceDB(if(0==sze(ff[0]=LocalSequenceDB.getTextForID(id)))){
            IF_FetchSeqs(ff[0]=dbfetchDbColonID2file(id));;
            ff[1]=file(hrefToUrlString(HREF_PROTEIN_FILE,id));
        }
        if(sze(ff[0])+sze(ff[1])==0){
            _url=url((hrefToUrlString(HREF_PROTEIN_FILE,id)));
            IF_GUI(adUniq(this,_refseqDownloadV));;
            IF_GUI(if(!_refseqDownloading) startThrd(this));;
            UNLESS_GUI(dlUrl(_url));;
        }
        if(sze(ff[0])+sze(ff[1])>0) _downloaded=true;
    }
/* <<< Instance <<< */
/* ---------------------------------------- */
/* >>> Init >>> */
    short[]u2i(){
        final Protein pu=_downloaded?refP():null,p=sp(_p);
        if(pu==null||p==null) return null;
        final byte[]aaU=pu.getResType(),aa=p.getResType();
        if(aaU.length*aa.length==0) return null;
        short[]u2i=_u2i;
        if(DIFF_MC(_mc,pu.mc(P_MC_RES_TYPE)+p.mc(P_MC_RES_TYPE)) || u2i==null && !ARRAY_EMPTY(aaU)){
            byte[][]aligned=gappedForPerfectMatch(aa,aaU);
            if(null==aligned && null==(aligned=smithWaterman(aa,aaU,null))) return null;
            final byte[]a0=aligned[0],a1=aligned[1];
            if(a0!=null && a1!=null){
                IF_DEACTIVATED(_ali=aligned);;
                IF_DEACTIVATED(_aliStartsAtIdx=maxi(0,strstr(STR_IC,a0,aa)));;
                java.util.Arrays.fill(_u2i=u2i=new short[aaU.length],(short)-1);
                short idxO=(short)idxOfLetters(a0,aa,0,MAX_INT);
                short idxU=(short)idxOfLetters(a1,aaU,0,MAX_INT);
                final int TO=mini(a0.length,a1.length);
                FORc(0,TO){
                    final boolean lO=isChrClas(LETTR,a0,c),lU=isChrClas(LETTR,a1,c);
                    if(lO && lU && 0<=idxU && idxU<u2i.length) u2i[idxU]=idxO;
                    if(lO) idxO++;
                    if(lU) idxU++;
                }
            }
        }
        return u2i;
    }
/* <<< Init <<< */
/* ---------------------------------------- */
/* >>> Thread >>> */
#if CPP_WITH_GUI
    OVERRIDE_PUBLIC void run(){
        CPP_synchronized(recordSync(_refseqDownloadV,"_refseqDownloadV")){
            _refseqDownloading=true;
            for(int n; (n=sze(_refseqDownloadV))>0;){
                ROFi0(n){
                    final ReferenceSequence rs=(ReferenceSequence)iThEl(i,_refseqDownloadV);
                    if(rs!=null){
                        dlUrl(rs._url);
                        rs._downloaded=true;
                        final Protein p=sp(_p);
                        if(rs.refP()!=null && p!=null){
                            strapIncMC(P_MC_RES_SELECTIONS,p);
                            strapIncMC(P_MC_RES_SELECTION_REFERENCE,p);
                            strapEvtDispatch(EVT_RESIDUE_SELECTION|SEVTMS*333);
                        }
                    }
                    _refseqDownloadV.remove(rs);
                }
                sleepMS(10);
            }
            _refseqDownloading=false;
        }
    }
#endif //CPP_WITH_GUI
/* <<< Thread <<< */
/* ---------------------------------------- */
/* >>> Getters >>> */
    Protein refP(){
        if(_pRef!=null) return _pRef;
        final Map m=mapSoft(156);
        Protein p=(Protein)m.get(_id);
        if(p==null){
            for(Object f:_files){
                if(sze(f)>0){
                    m.put(_id,p=newProteinInstance(PROTPARS_NO_HEADER|PROTPARS_NO_RESSEL,readBytes(f)));
                    break;
                }
            }
        }
        return p;
    }
    boolean[]refIdx2Idx(boolean[]uniprot,int offset,int[]returnMinIdx){
        final short[]u2i=u2i();
        if(u2i==null) return NO_boolean;
        final int offs=offset-firstResIdx(_pRef),N=mini(sze(u2i),uniprot.length+offs);
        int min=MAX_INT,max=MIN_INT;
        for(int i=N;--i>=offs;){
            if(uniprot[i-offs]){
                final int idx=u2i[i];
                if(idx<min) min=idx;
                if(idx>max) max=idx;
            }
        }
        if(min>max) return NO_boolean;
        max=mini(min+99999,max);
        final boolean[]bb=new boolean[max-min+1];
        for(int i=N;--i>=offs;) if(uniprot[i-offs]) bb[u2i[i]-min]=true;
        returnMinIdx[0]=min+firstResIdx(sp(_p));
        return bb;
    }
#if CPP_WITH_GUI
#if CPP_DEACTIVATED
    private byte[][]_ali;
    private int _aliStartsAtIdx;
    BA localAlignment(int aFrom,int aTo,BA sb){
        if(!_downloaded) return null;
        final int[]fromToCol={0,0};
        countMismatch(aFrom,aTo,fromToCol);
        final byte[]aa[]=_ali,a0=aa[0],a1=aa[1],mid[]=similarityMatrix(SIMILARITY_MATRIX_BL2SEQ_MIDLINE);
        final int f=maxi(fromToCol[0],0),t=mini(fromToCol[1],a0.length,a1.length);
        sb.an(' ',sze(_id)+1).aFT(a0,f,t).a('\n').an(' ',sze(_id)+1);
        FORi(f,t) sb.a((char)mid[a0[i]&127][a1[i]&127]);
        return sb.a('\n').a(_id).a(' ').aFT(a1,f,t).a('\n');
    }
    int countMismatch(int fromIdx,int toIdx,int[]colFromTo){
        if(!_downloaded) return MAX_INT;
        final byte[]a0=_ali[0],a1=_ali[1];
        int mismatch=0;
        if(colFromTo!=null) colFromTo[0]=-1;
        for(int iA=_aliStartsAtIdx,i=0;i<a0.length && i<a1.length;i++){
            if(isChrClas(LETTR,a0,i)){
                if(iA>=fromIdx-2){
                    if((a0[i]|32)!=(a1[i]|32)) mismatch++;
                    if(colFromTo!=null){
                        if(colFromTo[0]<0) colFromTo[0]=i;
                        colFromTo[1]=i+1;
                    }
                }
                if(iA++>toIdx) break;
            }
        }
        return mismatch;
    }
#endif //CPP_DEACTIVATED
#endif //CPP_WITH_GUI
/* <<< Getters <<< */

}
