/* >>> Base90 >>> */
private static byte[]_base90;
 static byte[]b90Charcodes(){
    byte[]dd=_base90;
    if(dd==null){
        dd=_base90=new byte[B90_DIGITS];
        int count=0;
        FORi(33,127) if(i!=B90_NAN && i!='-' && i!=B90_BLOCK) dd[count++]=(byte)i;
        IF_MEIN_DEBUG(if(count!=B90_DIGITS) baOut(RED_WARNING).aa(" count=",count," B90_DIGITS=",B90_DIGITS).special(DIE_NOW));;
    }
    return dd;
}
private static int[]_ascii90;
 static int[]charcodeToBase90(){
    int[]a90=_ascii90;
    if(a90==null){
        final byte[]digits=b90Charcodes();
        a90=_ascii90=new int[128];
        ROFi0(digits.length) a90[digits[i]]=i;
    }
    return a90;
}
private static int base90ToInt(byte[]T,int f,int t){
    if(t-f<1) return 0;
    int v=0;
    for(int a90[]=charcodeToBase90(),i=T[f]=='-'?f+1:f;i<t;i++)v=v*B90_DIGITS+a90[T[i]&127];
    return T[f]=='-'?-v:v;
}
private static void intToBase90(int n,BA sb){
    final byte[]digits=b90Charcodes();
    if(n==0) sb.a((char)digits[0]);
    int e=sb.end();
    final byte[]T=sb.ensureCapacity(e+16);
    if(n<0){T[e++]='-';n=-n;}
    final int invertStart=e;
    while(n!=0){
        final int div=n/B90_DIGITS;
        T[e++]=digits[n-div*B90_DIGITS];
        n=div;
    }
    sb.setEnd(e).invertText(invertStart,e);
}
/* <<< Strap Base 90 <<< */
/* ---------------------------------------- */
/* >>> Strap XYZ Base 90 >>> */
/* MAX_INT/1000f=2147483 */
#define T_MULT_3_LESS_XYZ_LENGTH(t) if(t>MAX_INT/3||(t*=3)>xyz.length)t=xyz.length
 static void xyzAddNans(float[]xyz,int f,int t){
    T_MULT_3_LESS_XYZ_LENGTH(t);
    FORi(maxi(0,3*f),t) if(Float.isNaN(xyz[i])) xyz[i-=i%3]=xyz[++i]=xyz[++i]=Float.NaN;
}
private static long xyzRangeNotNaN(float[]xyz,int f,int t){
    xyzAddNans(xyz,f,t);
    int b=-1,e=-1;
    T_MULT_3_LESS_XYZ_LENGTH(t);
    for(int i=maxi(0,3*f);i<t;i+=3){
        if(!Float.isNaN(xyz[i])){
            if(b==-1)b=i;
            e=i;
        }
    }
    return b==-1?0:RANGE_FROM_TO(b,e+1);
}
/* !"#$%&'()*+,./0123456789:;<=?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|} */
/* A Block has the following three fields separated by >: */
/* first Value */
/* min difference */
/* Sequence of differences+min difference. These numbers take exactly two digits and are written comma-less. */
public static void xyz90FloatToText(float[]xyz,float precision,int fromAtom,int toAtom,BA sb){
    final byte[]digits=b90Charcodes();
    T_MULT_3_LESS_XYZ_LENGTH(toAtom);
    for(int i3=0;i3<3;i3++){ /*X First all X,then all Y,then all Z */
        for(int a=i3+3*fromAtom;a<toAtom;){
            //int countNaN=0;while(a<toAtom && Float.isNaN(xyz[a])) {countNaN++; a+=3;}
            while(a<toAtom && Float.isNaN(xyz[a])){a+=3; sb.a(B90_NAN);}
            if(a>=toAtom) break;
            final int ori=(int)(precision*xyz[a]),min,to;
            {/*X  to=How many can be encoded in two digits?   min=min difference between adjacent positions*/
                int t=a+3,mi=MAX_INT,ma=MIN_INT,lst=ori;/*X  Not Long.MAX_VALUE !!*/
                for(;t<toAtom;t+=3){
                    if(Float.isNaN(xyz[t-i3])) continue;
                    final int abs=(int)(xyz[t]*precision),diff=abs-lst;
                    lst=abs;
                    final int miTmp=diff<mi?diff:mi;
                    if(diff>ma) ma=diff;
                    if(ma-miTmp>=B90_DIGITS*B90_DIGITS) break;
                    mi=miTmp;
                }
                min=mi;
                to=t;
            }
            intToBase90(ori,sb);
            sb.a(B90_BLOCK);
            if(a+3<to) intToBase90(min,sb);
            sb.a(B90_BLOCK);
            if((a+=3)<to){
                long lst=ori;
                for(;a<to;a+=3){
                    if(Float.isNaN(xyz[a])) sb.a(B90_NAN);
                    else{
                        final long abs=(long)(xyz[a]*precision),diff=abs-lst;
                        lst=abs;
                        final long v=diff-min;
                        //if (i3==debugColumn) baOut(DEBUG_NOW+"v=").a(v).aln();
                        IF_MEIN_DEBUG(if(v<0) assrt());;
                        final int hi=(int)(v/B90_DIGITS);
                        sb.aa((char)digits[hi],(char)digits[(int)(v-hi*B90_DIGITS)]);
                        //sb.a("  "+ANSI_FG_GREEN).a(v).a(ANSI_RESET+"("+diff+" "+min+")  "+ANSI_RESET);
                    }
                }
            }
            sb.a(B90_BLOCK);
        }
        sb.del(B90_BLOCK).a(' ');
    }
}
public static int xyz90FromText(float[]xyz,float reciprocalPrecision,byte[]T,int fromPos,int toPos){
    final int[]digits=charcodeToBase90();
    if(xyz==null) return 0;
    int i=0;
    for(int i3=0,from=fromPos,to;i3<3;i3++,from=to+1){
        to=strchr(' '|STR_E,T,from,toPos);
        i=i3;
        for(int t=from;t<to;){
            while(t<to&&T[t]==B90_NAN) {if(xyz.length>i) xyz[i]=Float.NaN; i+=3; t++;}
            long v=0;
            final long min;
            { /*X Ori-Value and Min-diff-value */
                final int oriB=t,oriE=strchr(B90_BLOCK|STR_E,T,t+1,to);
                t=strchr(B90_BLOCK,T,oriE+1,to)+1;
                if(i<xyz.length) xyz[i]=reciprocalPrecision * (v=base90ToInt(T,oriB,oriE));i+=3;
                min=t<to?base90ToInt(T,oriE+1,t-1):0;
                //if (i3==debugColumn) baOut(DEBUG_NOW+"MIN=").aa(min," ORI=",v,"  ",s(T,oriB,oriE)).aln();
            }
            for(;t<to;i+=3){
                final int b=T[t]&127;
                if(b==B90_BLOCK) {t++;break;}
                if(b==B90_NAN){
                    if(xyz.length>i) xyz[i]=Float.NaN;
                    t++;
                }else{
                    //if (i3==debugColumn) baOut(DEBUG_NOW+"v=").a((digits[b]*B90_DIGITS)+digits[T[t+1]&127]).aln();
                    if(xyz.length>i) xyz[i]=reciprocalPrecision * (v+=min+(digits[b]*B90_DIGITS)+digits[T[t+1]&127]);
                    t+=2;
                }
            }
        }
        //if(i3==debugColumn) return i/3;
    }
    return i/3;
}
/* <<< Base90 <<< */
/* ---------------------------------------- */
/* >>> Strap Fromat >>> */
private static boolean isUcFirstAndNoLC(int n){
    int b=n&255;
    if(!(IS_UPPER(b))) return false;
    while((n>>>=8)!=0) if('a'<=(b=n&255) && b<='z') return false;
    return true;
}
public Collection sequenceInStrapFormat(int opt,BA sb,Collection<byte[]>vTxt){
    if(sb==null) sb=new BA(999);
    if(vTxt==null && 0==(opt&SEQW_DIRECTLY_INTO_SB)) vTxt=new ArrayList();
    final int subsetEnd=subsetEnd(),nR=subsetEnd-subsetStart();
    int count,e0=0;
    Object v;
    final byte[]rr=getResidueType();
    final boolean hetero=getIntProperty(PROTEINI_CHAINTYPE)==CHAINTYPE_HET;
    if(!hetero && 0==(opt&SEQW_ONLY_COORDINATES)){
        if(vTxt!=null) clr(sb);
        if(subsetEnd-subsetStart()>0){
            e0=sb.a(SCRIPT_aa_sequence).end();
            final byte[]T=sb.ensureCapacity(e0+nR+6);
            FORi(subsetStart(),subsetEnd) T[e0++]=(byte)(residueHasXYZ(false,i)?(rr[i]&=~32): (rr[i]|32));
            sb.setEnd(e0).aln();
        }
        e0=sb.end();
        if(resnToSeries(0,sb.a(SCRIPT_res_num))) sb.aln(); else sb.setEnd(e0);
        e0=sb.end();
        if(toSeries(SERIES_INS,0,MAX_INT,sb.a(SCRIPT_res_ins))) sb.aln(); else sb.setEnd(e0);
        sb.and(SCRIPT_chain,getChain(),"\n");
        {
            final int[]nn32=getResidueName32();
            if(nn32!=null){
                count=0;
                final int n=mini(subsetEnd,nn32.length,rr.length);
                FORi(subsetStart(),n){
                    final int n32=nn32[i];
                    if((n32!=0 && (n32&0xFFffFF)!=(toThreeLetterCode(rr[i])&0xFFffFF))){
                        if(count++==0) sb.a(SCRIPT_res_name);
                        sb.aa((char)rr[i],i-subsetStart(),'=').aBytesAdj(n32,4);
                    }
                }
                if(count>0) sb.aln();
            }
        }
        e0=sb.end();
        {
            final byte[]secStru=getResidueSecStrType();
            final boolean[]lettr_digt_us=chrClas(LETTR_DIGT_US);
            for(int L=sze(secStru)+1;--L>0;){
                if(isChrClas(lettr_digt_us,secStru,L-1)){
                    sb.a(SCRIPT_res_secstru_90);
                    final byte[]chars=b90Charcodes();
                    for(int i=0,lastC=INT_NAN,lastI=0;i<=L;i++){
                        int c=i==L?0:secStru[i];
                        if(c<'0'||c>127||!lettr_digt_us[c]) c=0;
                        if(c!=lastC || i-lastI>=B90_DIGITS-1){
                            if(i>0) sb.aa((char)chars[i-lastI],lastC==0?'-':(char)lastC);
                            lastC=c;
                            lastI=i;
                        }
                    }
                    sb.aln();
                    break;
                }
            }
        }
        ROFi0(3){
            final Object txt=getProperty(i==0?P_TITLE: i==1?P_COMPOUND: P_ORGANISM_SC);
            if(sze(txt)>0) sb.aa(i==0?SCRIPT_set_TI: i==1?SCRIPT_set_DE: SCRIPT_set_OS,txt).aln();
        }
        if(sze(v=getProperty(PROTEINO_EC))>0) sb.a(SCRIPT_set_EC).joinSpc(v).aln();
        if((count=getIntProperty(PROTEINI_TAXID))!=0) sb.a(SCRIPT_taxid).a(count).aln();
        {
            final String acc=seqId(GETSEQID_ACCESSION);
            if(acc!=null) sb.aa(SCRIPT_AC,acc).aln();
            count=0;
            for(String s:getRefs(0)){
                if(eqNz(acc,s)) continue;
                if(count++==0) sb.a(SCRIPT_xref);
                sb.aa(s,' ');
            }
            if(count>0) sb.del(' ').aln();
        }
        {
            final Protein[]hh=getMolecules(CHAINTYPE_HET);
            if(hh.length>0){
                sb.aln("# "+ANSI_CYAN);
                for(Protein h:hh)h._flags&=~PFLAG_TEMP;
                for(Protein h:hh){
                    if((h._flags&PFLAG_TEMP)==0){
                        final int n32=h.getResidueName32()[0];
                        Object n=null;
                        sb.a(SCRIPT_add_het);
                        for(Protein h2:hh){
                            if(h2.getResidueName32()[0]==n32){
                                h2._flags|=PFLAG_TEMP;
                                sb.aa(h2,' ');
                                if(sze(n)==0) n=h2.getProperty(P_TITLE);
                            }
                        }
                        sb.and("\"",n,"\"").aln();
                    }
                }
                sb.aln("# "+ANSI_RESET);
            }

        }
        mkStrapScriptRessel(opt|SSCRIPT_SEQFEAT,sb);
    }
    float[]xyz;
    if(!hetero && 0!=(opt&(SEQW_CALPHA_ATOMS)) && (xyz=getResidueCalphaCurrent())!=null){
        xyzAddNans(xyz,0,nR);
        final long ft=xyzRangeNotNaN(xyz,subsetStart(),nR);
        final int f=(int)(ft>>>RANGEFROM_SHIFT);
        if(f>=0){
            xyz90FloatToText(xyz,XYZ90_PRECISION_CALPHA,f,(int)(ft&RANGETO_MASK),sb.a("\n"+SCRIPT_xyzAlpha));
            if(f!=0) sb.a1(' ').aHex(f);
            sb.delBlanksR().aln().aln().bytesToCollection(vTxt);
        }
    }
    if(!hetero){
        sb.bytesToCollection(vTxt);
        final Object[][]biomt=(Object[][])getProperty(PROTEINO_BIOMT);
        if(biomt!=null){
            final Map<Object,Object>mapRefCount=new HashMap(),mapVarNames=new HashMap();
            for(Object[]mol:biomt){
                for(Matrix3D m3d:(Matrix3D[])mol[ASSEMBLY_MATRICES]) mapRefCount.put(m3d,io(1+xatoi(mapRefCount.get(m3d))));
            }
            int varName=1;
            final BA sbMx=baClr(107);
            for(Object[]mol:biomt){
                sbMx.aa(SCRIPT_biomt,mol[ASSEMBLY_ID],' ').join('|',mol[ASSEMBLY_CHAINS]).a(' ');
                for(Matrix3D m3d:(Matrix3D[])mol[ASSEMBLY_MATRICES]){
                    if(xatoi(mapRefCount.get(m3d))>1){
                        Object var=mapVarNames.get(m3d);
                        if(var==null){
                            mapVarNames.put(m3d,var=io(varName++));
                            sb.aa(SCRIPT_let+"$mx",var,'=');
                            m3d.toText(MTRX_FORMAT_PLAIN_VBAR,null,sb).aln().bytesToCollection(vTxt);
                        }
                        sbMx.a(" $mx").a(mapVarNames.get(m3d));
                    }else{
                        m3d.toText(MTRX_FORMAT_PLAIN_VBAR,null,sbMx.a(' '));
                    }
                }
                sbMx.aln();
            }
            sb.aln().aln(sbMx).bytesToCollection(vTxt);
        }
    }
    if(0!=(opt&SEQW_SIDE_CHAIN_ATOMS) && null!=(xyz=getAtomXYZ())){
        final int[]atomF=getResidueAtomIdx(),rAtomNum=getResidueAtomNumber();
        for(int amino=subsetStart(),initialized=0,aminoCount=INT_NAN,rAtomNumThis=1;amino<subsetEnd&&amino<atomF.length;amino++){
            if(atomF[amino]<0) continue;
            final short[]ee=getResidueElement(false,amino);
            if(ee.length==0) continue;
            xyzAddNans(xyz,0,MAX_INT);
            xyz90FloatToText(xyz,XYZ90_PRECISION,atomF[amino],atomF[amino]+ee.length,sb.a(SCRIPT_xyz));
/*X Order is important: H=... #=... then i=... */
            if(hetero) resnAsText(0,0,sb.aBYTES('H','=').aBytes(getResidueName32()[0]).a('_')).a(' ');
            if(initialized++==0) sb.aBYTES('#','=').aHex(xyz.length/3).a(' ');
            {
                final int[]nn=getResidueAtomNumberOffsets(amino);
                if(nn!=null) seriesToTextN(0,nn,nn.length,1,0,0,sb.aBYTES('i','=')).a(' ');
            }
             if(!hetero && amino!=aminoCount) sb.aBYTES('I','=').aHexSgn(aminoCount=amino).a(' ');
            {
                final int[]aa=getResidueAtoms32(true,amino);/*X  N,CA,C,O,CB,CG1,CG2 */
                if(aa!=null){
                    sb.aBYTES('a','=');
                    boolean needKomma=false;
                    for(int a:aa) if(needKomma=!isUcFirstAndNoLC(a)) break;
                    for(int a:aa) if(needKomma) sb.a(',').aBytes(a); else sb.aUcfirst(a);
                    sb.a(' ');
                }
                if(getResidueElement(true,amino).length>0){
                    sb.aBYTES('e','=');
                    boolean needKomma=false;
                    for(short e:ee) if(needKomma=!isUcFirstAndNoLC(e)) break;
                    for(short e:ee) if(needKomma) sb.a(',').aBytes(e); else sb.aUcfirst(e);
                    sb.a(' ');
                }

            }
            if(rAtomNum!=null&&rAtomNumThis!=rAtomNum[amino]) sb.aBYTES('n','=').aHexSgn(rAtomNumThis=rAtomNum[amino]).a(' ');
            rAtomNumThis+=ee.length;
            aminoCount++;
            sb.delBlanksR().aln().bytesToCollection(vTxt);
        }
        if(!hetero && 0!=(opt&SEQW_HETEROS)){
            final Protein[]hh=getMolecules(CHAINTYPE_HET);
            if(hh.length>0){
                sb.aln('#'+ANSI_FG_GREEN);
                FORi(0,hh.length) hh[i].sequenceInStrapFormat(opt,sb,vTxt);
                sb.aln('#'+ANSI_RESET);
            }
        }
    }
    sb.bytesToCollection(vTxt);
    return vTxt;
}
/* <<< Write Strap Format <<< */
/* ---------------------------------------- */
/* >>> Strap-Script >>> */
 static void mkStrapScript(int opt,Protein[]pp,BA temp,Collection<byte[]>vScript){
    final int aliType=strapAlignmentType(),countVar[]={0};
    final Map<String,String>mapVar=new HashMap();
    int e0;
    Object v;
    if(aliType==iSCRIPT_alignment_type_N||aliType==iSCRIPT_alignment_type_n||aliType==iSCRIPT_alignment_type_CN||aliType==iSCRIPT_alignment_type_P)  clr(temp).aln(iConst(SARRAY_STRAP_SCRIPT_CMD,aliType));
    for(Protein p:pp){
        if(0==(opt&SSCRIPT_HIDDEN_SEQ) && (p._flags&PFLAG_IN_ALI)==0) continue;
        final int pos1=temp.a(SCRIPT_let+"$p=").aln(p).end(),pos2=temp.end();
        {
            final boolean needAA=p.exons()==null || !strEquAt(STR_IC,p.getResType(),triplets2aa(true,p.triplets(),MAX_INT),0);/*X  E.G. mRNA editing */
            if(p.exons()!=null){
                temp.a(SCRIPT_nt_sequence);
                if(!needAA) _mkStrapScriptGappedCDS(p,temp); else temp.a(p.triplets());
                temp.a(',').and(" moleculeType=",iConst(SARRAYeq_SEQ_MOL_TYPES,p.getIntProperty(PROTEINI_MOL_TYPE))," ");
                Bitset.toText(p.exons(),p.isReverseComplement(),temp).aln(",$p");
            }
            if(needAA){
                e0=temp.a(aliType==iSCRIPT_alignment_type_N||aliType==iSCRIPT_alignment_type_CN?SCRIPT_nt_sequence: aliType==iSCRIPT_alignment_type_P?SCRIPT_aa_sequence: SCRIPT_sequence).end();
                temp.aFT(p.getGappedSequence(false),0,p.getResColumnMax()+1).replaceChar(' ','-',e0,MAX_INT).aln(",$p");
            }
        }
        if(p.getIntProperty(PROTEINI_NT_IDX_OFFSET)!=0) temp.a(SCRIPT_set_nucleotide_index_offset).a(p.getIntProperty(PROTEINI_NT_IDX_OFFSET)).aln(",$p");
        //if ((v=p.getIntProperty(PROTEINI_MOL_TYPE))!=null)  temp.and(SCRIPT_set_molecule_type,v,",$p\n");
        if((v=getColrO(p))!=null) temp.a(SCRIPT_color+'#').aFT(v,0,8).aln(",$p");
        {
            final String pdb=p.getPdbID(PDBID_ID|PDBID_INFERRED);
            if(pdb!=null && p.isProteinStructure()){
                if(p.getPdbID(PDBID_ID)!=null) temp.aa(SCRIPT_xref,p.getPdbID(PDBID_ID),",$p\n");
                else temp.aa(SCRIPT_set_similar_pdb,pdb,",$p\n");
                if(0!=(opt&SSCRIPT_PROJECT_COORDINATES)) temp.aa(SCRIPT_project_XYZ,pdb,",$p\n");
            }
            e0=temp.end();
            if(p.resnToSeries(0,temp.a(SCRIPT_res_num))) temp.aln(",$p"); else temp.setEnd(e0);
            e0=temp.end();
            if(p.toSeries(SERIES_INS,0,MAX_INT,temp.a(SCRIPT_res_ins))) temp.aln(",$p"); else temp.setEnd(e0);
            e0=temp.end();
            if(p.aSecStru(temp.a(SCRIPT_res_secstru))) temp.aln(",$p"); else temp.setEnd(e0);
            temp.and(SCRIPT_chain,p.getChain(),",$p\n");
            if(p.getIntProperty(PROTEINI_AA_IDX_OFFSET)!=0) temp.aa(SCRIPT_set_residue_index_offset,p.getIntProperty(PROTEINI_AA_IDX_OFFSET)).aln(",$p");
            {
                final String acc=p.seqId(GETSEQID_ACCESSION),rr[]=p.getRefs(0);
                if(acc!=null && !acc.equals(pdb)) temp.aa(SCRIPT_AC,acc,",$p\n");
                final int end=temp.end();
                boolean ok=false;
                temp.a(SCRIPT_xref);
                for(String r:rr) if(!r.equals(acc) && !r.equals(pdb)) {temp.aa(r,' '); ok=true;}
                if(ok) temp.aln(",$p"); else temp.setEnd(end);
            }
        }
        if((v=getColrO(p))!=null) temp.aa(SCRIPT_color+'#',v,",$p\n");
        temp.a1('\n');
        if(0==(opt&SSCRIPT_NO_RESSEL)) p.mkStrapScriptRessel(opt,temp);
        {
            final Matrix3D m3d=p.getRotationAndTranslation();
            if(!isUnitOrNull(m3d)) m3d.toText(0,null,temp.a(SCRIPT_rotate_translate)).aln(",$p");
            if(0==(SSCRIPT_NO_ICONS&opt) && null!=(v=_mkStrapScriptVariable(orS(p.iconURL(),p.iconBase64()),temp,mapVar,countVar)))  temp.aa(SCRIPT_icon,v,",$p\n");
            for(String s:splitLns(p.balloonText(IF_GUI(SEQ_BALLOON_HTML)))) temp.and(SCRIPT_balloon_text,s,",$p\n");
            if(temp.end()==pos2) temp.setEnd(pos1);
            else temp.a('\n');
        }
        {
            Collection<String>vF=null;
            int countH=0;
            for(Protein h:p.getMolecules(CHAINTYPE_NUC_OR_HET)){
                if(h.getFile()!=null && p.getPdbID(PDBID_ID)!=null){
                    if(vF==null) (vF=new ArrayList()).add(s(p.getFile()));
                    if(adUniq(s(h.getFile()),vF)){
                        if(countH++==0) temp.a(SCRIPT_add_het);
                        temp.and("PDB:",pdbID(p.getPdbID(PDBID_ID))).and("_",h.getChain()).a(' ');
                    }
                }
            }
            if(countH>0) temp.aln(",$p");
        }
        temp.bytesToCollection(vScript);
    }
    FORi(0,SI_VALUES_SIZE) if(SI_VALUES[i]!=null) temp.aa(iConst(SARRAY_STRAP_SCRIPT_CMD,i),' ').aln(SI_VALUES[i]);
    Strap.exportSequenceGroups(null,temp);
    if(0!=(opt&SSCRIPT_3D)){/*X FIXME Nachdenken URLs der Proteine */
        temp.a('#').an('3',80).a('\n');
        for(Map.Entry<String,Collection>e: entryArry(V3D_MAP_ID_TO_VV)){
            temp.aa(SCRIPT_open_3D,e.getKey(),',');
            Collection recorded=null;
            for(View3d v0:v3dToArry(e.getValue())){
                final Protein p=sp(v0);
                if(p!=null){
                    temp.aa(0!=(p._flags&PFLAG_EXTERNAL)?p.getProperty(PROTEINO_WEB_TOK_WITH_SUBSET): p," ");
                    if(recorded==null) recorded=v3dRecordGeneric(null,v0);
                }
            }
            temp.a('\n');
            for(int i=0,R=sze(recorded);i<R;i++) temp.a(iThEl(i,recorded)).a1('\n');
        }
    }
    temp.bytesToCollection(vScript);
}/*X mkStrapScript*/
private void mkStrapScriptRessel(int opt,BA sb){
    IF_GUI(final Object[]selAA=(opt&SSCRIPT_SELECTED_RESSEL)==0?null:selectedResidueSelections(SOBJECT_RESAN));;
    //final String pdb=getPdbID(PDBID_ID|PDBID_INFERRED);
    for(ResidueAnnotation a:residueAnnotations()){
        //putln(" pdb="+pdb+" a.dataSrc="+a.dataSrc());
        //if (eqNz(pdb,a.dataSrc())) continue;
        if(0==(opt&SSCRIPT_HIDDEN_RESSEL) && (0==(a.getVisibleWhere()&VIS123_SEQUENCE) || a.isHiddenInHTML()) || fstTrue(a.getSelectedAminoacids())<0) continue;
        IF_GUI(if(((opt&SSCRIPT_SELECTED_RESSEL)==0 || cntainsEl(a,selAA)) && ((opt&SSCRIPT_SEQFEAT)!=0 || a.featureName()==null || 0!=(a._resanFlags&RESANFLAG_FROM_FILE)))){
            final String n=a.getName(),positions=resSelSimplifyPos(0,a);
            //  ||Modified residue|4|4|.|+|.|Note=Phosphotyrosine
            sb.a(SCRIPT_GFF).an('|',2).aa(n,'|',positions).an('|',3).an('+',a.isAmino()?0:1).an('|',2);
            final BA sbAnno=baClr(108);
            for(ResidueAnnotation.Entry e:a.entries()){
                final String v=e.value();
                final int ki=e._ki;
                if(ki==IRESAN_POS||ki==IRESAN_NAME||ki==IRESAN_COLOR||!e.isEnabled() IF_GUI(||v.indexOf(HREF_PAIR_ALIGNMENT)>=0)||
                   v.indexOf(SEQFEAT_ALI_SCORE)>=0||
                   ki==IRESAN_HIDDEN && !isTrue(v)) continue;
                final boolean variable=v.indexOf('$')>=0,spcOrVariable=variable || v.indexOf(' ')>=0;
                if(spcOrVariable && v.indexOf('"')>=0){
                    sbAnno.aa(SCRIPT_add_annotation,shrtClasNam(e.key())).an('\'',variable?1:0).a('=').an('\'',variable?1:0).a(v).an('\'',variable?1:0).aln(",~");
                }else{
                    sb.a(e.key()).aBytes(spcOrVariable?('='|('"'<<8)):'=').a(v).aBytes(spcOrVariable?('"'|(' '<<8)):' ');
                }
            }
            if(0!=(a._resanFlags&RESANFLAG_COLOR_SET)) sb.a(KRESAN_COLOR).aBytes('='|('#'<<8)).aa(getColrO(a)," ");
            sb.aln().a(sbAnno);
        }
    }
}
private static void _mkStrapScriptGappedCDS(Protein p,BA sb){
    final byte[]cds=p.triplets(),gg=p.getGappedSequence(false);
    final int L=p.getResColumnMax()+1;
    final boolean[]lettr=chrClas(LETTR);
    sb.ensureCapacity(sb.end()+cds.length+L);
    for(int i=0,n=0;i<L;i++){
        if(gg[i]==0) break;
        if(iThBool(gg[i],lettr)){
            if(cds.length>n+2) sb.aa((char)cds[n],(char)cds[n+1],(char)cds[n+2]);
            n+=3;
        }else{
            sb.a('-');
        }
    }
}
private static String _mkStrapScriptVariable(String data,BA sb,Map<String,String>mapVar,int[]count){
    if(sze(data)==0) return null;
    String v=mapVar.get(data);
    if(v==null){
        mapVar.put(data,v=new BA(10).aa("$V",++count[0]).toString());
        sb.aa(SCRIPT_let,v,'=').aln(data);
    }
    return v;
}
#undef B90_BLOCK
/* <<<  <<< */
/* ---------------------------------------- */
/* >>> Debug >>> */
#if CPP_WITH_MEIN_DEBUG&&0
#include "Protein_writeStrapFormat_Debug_Inc.java"
#endif //CPP_WITH_MEIN_DEBUG&&0
